/* history-button.c generated by valac 0.56.6, the Vala compiler
 * generated from history-button.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of a GNOME game

   Copyright (C) 2019 – Arnaud Bonatti <arnaud.bonatti@gmail.com>

   This application is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this application.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define HISTORY_BUTTON_usual_best_score_string _ ("Bravo! You finished the game!")
#define HISTORY_BUTTON_usual_best_score_string_untranslated "Bravo! You finished the game!"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HISTORY_BUTTON (history_button_get_type ())
#define HISTORY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY_BUTTON, HistoryButton))
#define HISTORY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY_BUTTON, HistoryButtonClass))
#define IS_HISTORY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY_BUTTON))
#define IS_HISTORY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY_BUTTON))
#define HISTORY_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY_BUTTON, HistoryButtonClass))

typedef struct _HistoryButton HistoryButton;
typedef struct _HistoryButtonClass HistoryButtonClass;
typedef struct _HistoryButtonPrivate HistoryButtonPrivate;
enum  {
	HISTORY_BUTTON_0_PROPERTY,
	HISTORY_BUTTON_NUM_PROPERTIES
};
static GParamSpec* history_button_properties[HISTORY_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HistoryButton {
	GtkMenuButton parent_instance;
	HistoryButtonPrivate * priv;
};

struct _HistoryButtonClass {
	GtkMenuButtonClass parent_class;
};

struct _HistoryButtonPrivate {
	guint best_score;
	guint last_moves_count;
};

static gint HistoryButton_private_offset;
static gpointer history_button_parent_class = NULL;

VALA_EXTERN GType history_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HistoryButton, g_object_unref)
static void history_button_update_state (HistoryButton* self,
                                  const gchar* label,
                                  gboolean sensitive);
static gchar* history_button_get_moves_count_string (guint* moves_count);
static void history_button_generate_moves_menu (HistoryButton* self);
static inline void history_button_generate_undo_actions_section (GMenu** menu);
static inline void history_button_generate_best_score_section (guint* best_score,
                                                 GMenu** menu);
VALA_EXTERN void history_button_save_best_score (HistoryButton* self,
                                     gchar** best_score_string);
static inline void history_button_get_best_score_string (guint* best_score,
                                           guint* last_moves_count,
                                           gchar** best_score_string);
VALA_EXTERN void history_button_new_game (HistoryButton* self);
VALA_EXTERN void history_button_set_moves_count (HistoryButton* self,
                                     guint moves_count);
VALA_EXTERN HistoryButton* history_button_new (void);
VALA_EXTERN HistoryButton* history_button_construct (GType object_type);
static GObject * history_button_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void history_button_finalize (GObject * obj);
static GType history_button_get_type_once (void);

static inline gpointer
history_button_get_instance_private (HistoryButton* self)
{
	return G_STRUCT_MEMBER_P (self, HistoryButton_private_offset);
}

static void
history_button_update_state (HistoryButton* self,
                             const gchar* label,
                             gboolean sensitive)
{
#line 36 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/history-button.vala"
	g_return_if_fail (label != NULL);
#line 38 "../src/history-button.vala"
	gtk_button_set_label ((GtkButton*) self, label);
#line 39 "../src/history-button.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, sensitive);
#line 125 "history-button.c"
}

static gchar*
history_button_get_moves_count_string (guint* moves_count)
{
	gchar* moves_count_string = NULL;
	gchar* result;
#line 45 "../src/history-button.vala"
	if ((*moves_count) != G_MAXUINT) {
#line 135 "history-button.c"
		gchar* _tmp0_;
#line 46 "../src/history-button.vala"
		_tmp0_ = g_strdup_printf ("%u", *moves_count);
#line 46 "../src/history-button.vala"
		_g_free0 (moves_count_string);
#line 46 "../src/history-button.vala"
		moves_count_string = _tmp0_;
#line 143 "history-button.c"
	} else {
		gchar* _tmp1_;
#line 48 "../src/history-button.vala"
		_tmp1_ = g_strdup ("∞");
#line 48 "../src/history-button.vala"
		_g_free0 (moves_count_string);
#line 48 "../src/history-button.vala"
		moves_count_string = _tmp1_;
#line 152 "history-button.c"
	}
#line 49 "../src/history-button.vala"
	result = moves_count_string;
#line 49 "../src/history-button.vala"
	return result;
#line 158 "history-button.c"
}

static void
history_button_generate_moves_menu (HistoryButton* self)
{
	GMenu* menu = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GMenu* _tmp2_;
#line 56 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/history-button.vala"
	_tmp0_ = g_menu_new ();
#line 58 "../src/history-button.vala"
	menu = _tmp0_;
#line 59 "../src/history-button.vala"
	history_button_generate_undo_actions_section (&menu);
#line 60 "../src/history-button.vala"
	if (self->priv->best_score != ((guint) 0)) {
#line 61 "../src/history-button.vala"
		history_button_generate_best_score_section (&self->priv->best_score, &menu);
#line 180 "history-button.c"
	}
#line 62 "../src/history-button.vala"
	_tmp1_ = menu;
#line 62 "../src/history-button.vala"
	g_menu_freeze (_tmp1_);
#line 63 "../src/history-button.vala"
	_tmp2_ = menu;
#line 63 "../src/history-button.vala"
	gtk_menu_button_set_menu_model ((GtkMenuButton*) self, (GMenuModel*) _tmp2_);
#line 56 "../src/history-button.vala"
	_g_object_unref0 (menu);
#line 192 "history-button.c"
}

static inline void
history_button_generate_undo_actions_section (GMenu** menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 66 "../src/history-button.vala"
	g_return_if_fail (*menu != NULL);
#line 68 "../src/history-button.vala"
	_tmp0_ = g_menu_new ();
#line 68 "../src/history-button.vala"
	section = _tmp0_;
#line 70 "../src/history-button.vala"
	g_menu_append (section, _ ("_Undo"), "ui.undo");
#line 73 "../src/history-button.vala"
	g_menu_append (section, _ ("_Restart"), "ui.restart");
#line 75 "../src/history-button.vala"
	g_menu_freeze (section);
#line 76 "../src/history-button.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 66 "../src/history-button.vala"
	_g_object_unref0 (section);
#line 216 "history-button.c"
}

static inline void
history_button_generate_best_score_section (guint* best_score,
                                            GMenu** menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 79 "../src/history-button.vala"
	g_return_if_fail (*menu != NULL);
#line 81 "../src/history-button.vala"
	_tmp0_ = g_menu_new ();
#line 81 "../src/history-button.vala"
	section = _tmp0_;
#line 84 "../src/history-button.vala"
	_tmp1_ = history_button_get_moves_count_string (best_score);
#line 84 "../src/history-button.vala"
	_tmp2_ = _tmp1_;
#line 84 "../src/history-button.vala"
	_tmp3_ = g_strdup_printf (_ ("Best score: %s"), _tmp2_);
#line 84 "../src/history-button.vala"
	_tmp4_ = _tmp3_;
#line 84 "../src/history-button.vala"
	g_menu_append (section, _tmp4_, NULL);
#line 84 "../src/history-button.vala"
	_g_free0 (_tmp4_);
#line 84 "../src/history-button.vala"
	_g_free0 (_tmp2_);
#line 86 "../src/history-button.vala"
	g_menu_freeze (section);
#line 87 "../src/history-button.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 79 "../src/history-button.vala"
	_g_object_unref0 (section);
#line 255 "history-button.c"
}

void
history_button_save_best_score (HistoryButton* self,
                                gchar** best_score_string)
{
	gchar* _vala_best_score_string = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 95 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/history-button.vala"
	history_button_get_best_score_string (&self->priv->best_score, &self->priv->last_moves_count, &_tmp0_);
#line 97 "../src/history-button.vala"
	_g_free0 (_vala_best_score_string);
#line 97 "../src/history-button.vala"
	_vala_best_score_string = _tmp0_;
#line 99 "../src/history-button.vala"
	if (self->priv->best_score == ((guint) 0)) {
#line 99 "../src/history-button.vala"
		_tmp1_ = TRUE;
#line 277 "history-button.c"
	} else {
#line 99 "../src/history-button.vala"
		_tmp1_ = self->priv->last_moves_count < self->priv->best_score;
#line 281 "history-button.c"
	}
#line 99 "../src/history-button.vala"
	if (_tmp1_) {
#line 100 "../src/history-button.vala"
		self->priv->best_score = self->priv->last_moves_count;
#line 287 "history-button.c"
	}
#line 101 "../src/history-button.vala"
	history_button_generate_moves_menu (self);
#line 95 "../src/history-button.vala"
	if (best_score_string) {
#line 95 "../src/history-button.vala"
		*best_score_string = _vala_best_score_string;
#line 295 "history-button.c"
	} else {
#line 95 "../src/history-button.vala"
		_g_free0 (_vala_best_score_string);
#line 299 "history-button.c"
	}
}

static inline void
history_button_get_best_score_string (guint* best_score,
                                      guint* last_moves_count,
                                      gchar** best_score_string)
{
	gchar* _vala_best_score_string = NULL;
#line 106 "../src/history-button.vala"
	if ((*best_score) == ((guint) 0)) {
#line 311 "history-button.c"
		gchar* _tmp0_;
#line 108 "../src/history-button.vala"
		_tmp0_ = g_strdup (HISTORY_BUTTON_usual_best_score_string);
#line 108 "../src/history-button.vala"
		_g_free0 (_vala_best_score_string);
#line 108 "../src/history-button.vala"
		_vala_best_score_string = _tmp0_;
#line 109 "../src/history-button.vala"
		if (best_score_string) {
#line 109 "../src/history-button.vala"
			*best_score_string = _vala_best_score_string;
#line 323 "history-button.c"
		} else {
#line 109 "../src/history-button.vala"
			_g_free0 (_vala_best_score_string);
#line 327 "history-button.c"
		}
#line 109 "../src/history-button.vala"
		return;
#line 331 "history-button.c"
	}
#line 112 "../src/history-button.vala"
	if ((*last_moves_count) < (*best_score)) {
#line 335 "history-button.c"
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 115 "../src/history-button.vala"
		_tmp1_ = g_strdup (_ ("Bravo! You improved your best score!"));
#line 115 "../src/history-button.vala"
		_g_free0 (_vala_best_score_string);
#line 115 "../src/history-button.vala"
		_vala_best_score_string = _tmp1_;
#line 116 "../src/history-button.vala"
		_tmp2_ = _vala_best_score_string;
#line 116 "../src/history-button.vala"
		if (g_strcmp0 (_tmp2_, "Bravo! You improved your best score!") != 0) {
#line 117 "../src/history-button.vala"
			if (best_score_string) {
#line 117 "../src/history-button.vala"
				*best_score_string = _vala_best_score_string;
#line 352 "history-button.c"
			} else {
#line 117 "../src/history-button.vala"
				_g_free0 (_vala_best_score_string);
#line 356 "history-button.c"
			}
#line 117 "../src/history-button.vala"
			return;
#line 360 "history-button.c"
		}
	} else {
#line 119 "../src/history-button.vala"
		if ((*last_moves_count) == (*best_score)) {
#line 365 "history-button.c"
			gchar* _tmp3_;
			const gchar* _tmp4_;
#line 122 "../src/history-button.vala"
			_tmp3_ = g_strdup (_ ("Bravo! You equalized your best score."));
#line 122 "../src/history-button.vala"
			_g_free0 (_vala_best_score_string);
#line 122 "../src/history-button.vala"
			_vala_best_score_string = _tmp3_;
#line 123 "../src/history-button.vala"
			_tmp4_ = _vala_best_score_string;
#line 123 "../src/history-button.vala"
			if (g_strcmp0 (_tmp4_, "Bravo! You equalized your best score.") != 0) {
#line 124 "../src/history-button.vala"
				if (best_score_string) {
#line 124 "../src/history-button.vala"
					*best_score_string = _vala_best_score_string;
#line 382 "history-button.c"
				} else {
#line 124 "../src/history-button.vala"
					_g_free0 (_vala_best_score_string);
#line 386 "history-button.c"
				}
#line 124 "../src/history-button.vala"
				return;
#line 390 "history-button.c"
			}
		} else {
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 129 "../src/history-button.vala"
			_tmp5_ = g_strdup (_ ("Bravo! You finished the game again."));
#line 129 "../src/history-button.vala"
			_g_free0 (_vala_best_score_string);
#line 129 "../src/history-button.vala"
			_vala_best_score_string = _tmp5_;
#line 130 "../src/history-button.vala"
			_tmp6_ = _vala_best_score_string;
#line 130 "../src/history-button.vala"
			if (g_strcmp0 (_tmp6_, "Bravo! You finished the game again.") != 0) {
#line 131 "../src/history-button.vala"
				if (best_score_string) {
#line 131 "../src/history-button.vala"
					*best_score_string = _vala_best_score_string;
#line 409 "history-button.c"
				} else {
#line 131 "../src/history-button.vala"
					_g_free0 (_vala_best_score_string);
#line 413 "history-button.c"
				}
#line 131 "../src/history-button.vala"
				return;
#line 417 "history-button.c"
			}
		}
	}
#line 134 "../src/history-button.vala"
	if (g_strcmp0 (HISTORY_BUTTON_usual_best_score_string_untranslated, HISTORY_BUTTON_usual_best_score_string) != 0) {
#line 423 "history-button.c"
		gchar* _tmp7_;
#line 135 "../src/history-button.vala"
		_tmp7_ = g_strdup (HISTORY_BUTTON_usual_best_score_string);
#line 135 "../src/history-button.vala"
		_g_free0 (_vala_best_score_string);
#line 135 "../src/history-button.vala"
		_vala_best_score_string = _tmp7_;
#line 431 "history-button.c"
	}
#line 104 "../src/history-button.vala"
	if (best_score_string) {
#line 104 "../src/history-button.vala"
		*best_score_string = _vala_best_score_string;
#line 437 "history-button.c"
	} else {
#line 104 "../src/history-button.vala"
		_g_free0 (_vala_best_score_string);
#line 441 "history-button.c"
	}
}

void
history_button_new_game (HistoryButton* self)
{
#line 145 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/history-button.vala"
	self->priv->best_score = (guint) 0;
#line 148 "../src/history-button.vala"
	self->priv->last_moves_count = (guint) 0;
#line 149 "../src/history-button.vala"
	history_button_generate_moves_menu (self);
#line 456 "history-button.c"
}

void
history_button_set_moves_count (HistoryButton* self,
                                guint moves_count)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 153 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/history-button.vala"
	if (moves_count != ((guint) 0)) {
#line 156 "../src/history-button.vala"
		_tmp0_ = TRUE;
#line 472 "history-button.c"
	} else {
#line 156 "../src/history-button.vala"
		_tmp0_ = self->priv->best_score != ((guint) 0);
#line 476 "history-button.c"
	}
#line 155 "../src/history-button.vala"
	_tmp1_ = history_button_get_moves_count_string (&moves_count);
#line 155 "../src/history-button.vala"
	_tmp2_ = _tmp1_;
#line 155 "../src/history-button.vala"
	history_button_update_state (self, _tmp2_, _tmp0_);
#line 155 "../src/history-button.vala"
	_g_free0 (_tmp2_);
#line 157 "../src/history-button.vala"
	self->priv->last_moves_count = moves_count;
#line 488 "history-button.c"
}

HistoryButton*
history_button_construct (GType object_type)
{
	HistoryButton * self = NULL;
#line 24 "../src/history-button.vala"
	self = (HistoryButton*) g_object_new (object_type, NULL);
#line 24 "../src/history-button.vala"
	return self;
#line 499 "history-button.c"
}

HistoryButton*
history_button_new (void)
{
#line 24 "../src/history-button.vala"
	return history_button_construct (TYPE_HISTORY_BUTTON);
#line 507 "history-button.c"
}

static GObject *
history_button_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HistoryButton * self;
#line 26 "../src/history-button.vala"
	parent_class = G_OBJECT_CLASS (history_button_parent_class);
#line 26 "../src/history-button.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 26 "../src/history-button.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY_BUTTON, HistoryButton);
#line 28 "../src/history-button.vala"
	history_button_update_state (self, "0", FALSE);
#line 29 "../src/history-button.vala"
	history_button_generate_moves_menu (self);
#line 26 "../src/history-button.vala"
	return obj;
#line 530 "history-button.c"
}

static void
history_button_class_init (HistoryButtonClass * klass,
                           gpointer klass_data)
{
#line 24 "../src/history-button.vala"
	history_button_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/history-button.vala"
	g_type_class_adjust_private_offset (klass, &HistoryButton_private_offset);
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (klass)->constructor = history_button_constructor;
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (klass)->finalize = history_button_finalize;
#line 24 "../src/history-button.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Taquin/ui/history-button.ui");
#line 547 "history-button.c"
}

static void
history_button_instance_init (HistoryButton * self,
                              gpointer klass)
{
#line 24 "../src/history-button.vala"
	self->priv = history_button_get_instance_private (self);
#line 94 "../src/history-button.vala"
	self->priv->best_score = (guint) 0;
#line 152 "../src/history-button.vala"
	self->priv->last_moves_count = (guint) 0;
#line 24 "../src/history-button.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 562 "history-button.c"
}

static void
history_button_finalize (GObject * obj)
{
	HistoryButton * self;
#line 24 "../src/history-button.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY_BUTTON, HistoryButton);
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (history_button_parent_class)->finalize (obj);
#line 573 "history-button.c"
}

static GType
history_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HistoryButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) history_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HistoryButton), 0, (GInstanceInitFunc) history_button_instance_init, NULL };
	GType history_button_type_id;
	history_button_type_id = g_type_register_static (gtk_menu_button_get_type (), "HistoryButton", &g_define_type_info, 0);
	HistoryButton_private_offset = g_type_add_instance_private (history_button_type_id, sizeof (HistoryButtonPrivate));
	return history_button_type_id;
}

GType
history_button_get_type (void)
{
	static volatile gsize history_button_type_id__once = 0;
	if (g_once_init_enter (&history_button_type_id__once)) {
		GType history_button_type_id;
		history_button_type_id = history_button_get_type_once ();
		g_once_init_leave (&history_button_type_id__once, history_button_type_id);
	}
	return history_button_type_id__once;
}

