/* taquin-game.c generated by valac 0.56.6, the Vala compiler
 * generated from taquin-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Taquin.

   Copyright (C) 2014-2016 – Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME Taquin is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Taquin is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Taquin.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GAME_TYPE_FIFTEEN,
	GAME_TYPE_SIXTEEN
} GameType;

#define TYPE_GAME_TYPE (game_type_get_type ())

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;

#define GAME_TYPE_UNDO_ITEM (game_undo_item_get_type ())
typedef struct _GameUndoItem GameUndoItem;
enum  {
	GAME_0_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_GAME_TYPE_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
typedef enum  {
	GAME_BAD_CLICK_EMPTY_TILE,
	GAME_BAD_CLICK_NOT_MOVING,
	GAME_BAD_CLICK_IS_OUTSIDE,
	GAME_BAD_CLICK_USE_ARROWS
} GameBadClick;

#define GAME_TYPE_BAD_CLICK (game_bad_click_get_type ())
#define _game_undo_item_free0(var) ((var == NULL) ? NULL : (var = (game_undo_item_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
enum  {
	GAME_COMPLETE_SIGNAL,
	GAME_MOVE_SIGNAL,
	GAME_BAD_CLICK_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GameUndoItem {
	gint8 x;
	gint8 y;
	GameUndoItem* next;
	GameUndoItem* previous;
};

struct _GamePrivate {
	gint8 _size;
	GameType _game_type;
	gint8* tiles;
	gint tiles_length1;
	gint tiles_length2;
	GameUndoItem* state;
	GameUndoItem* previous_state;
	guint moves_count;
	gint8 x_gap;
	gint8 y_gap;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

VALA_EXTERN GType game_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* game_type_to_string (GameType self);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
static GType game_undo_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GameUndoItem* game_undo_item_dup (const GameUndoItem* self);
static void game_undo_item_free (GameUndoItem* self);
static void game_undo_item_copy (const GameUndoItem* self,
                          GameUndoItem* dest);
static void game_undo_item_destroy (GameUndoItem* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameUndoItem, game_undo_item_destroy)
VALA_EXTERN GType game_bad_click_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gint8 game_get_tile_value (Game* self,
                           gint8 x,
                           gint8 y);
VALA_EXTERN Game* game_new (GameType game_type,
                gint8 size);
VALA_EXTERN Game* game_construct (GType object_type,
                      GameType game_type,
                      gint8 size);
static void game_generate_game (GameType game_type,
                         gint8 size,
                         gint8** tiles,
                         gint* tiles_length1,
                         gint* tiles_length2);
static gint8* _int8_dup (gint8* self);
VALA_EXTERN gchar* game_to_string (Game* self);
VALA_EXTERN gint8 game_get_size (Game* self);
VALA_EXTERN void game_request_move (Game* self,
                        gint8 x,
                        gint8 y,
                        gboolean keyboard_call);
VALA_EXTERN GameType game_get_game_type (Game* self);
static void game_fifteen_move (Game* self,
                        gint8 x,
                        gint8 y,
                        gboolean undoing,
                        gboolean restarting);
static void game_sixteen_move (Game* self,
                        gint8 x,
                        gint8 y,
                        gboolean undoing,
                        gboolean restarting);
static gboolean game_check_complete (gint8** tiles,
                              gint* tiles_length1,
                              gint* tiles_length2);
static void game_add_move (Game* self,
                    gint8 x_gap,
                    gint8 y_gap);
VALA_EXTERN void game_undo (Game* self);
VALA_EXTERN void game_restart (Game* self);
static void game_set_size (Game* self,
                    gint8 value);
static void game_set_game_type (Game* self,
                         GameType value);
static void g_cclosure_user_marshal_VOID__BOOLEAN_CHAR_CHAR_CHAR_UINT_BOOLEAN (GClosure * closure,
                                                                        GValue * return_value,
                                                                        guint n_param_values,
                                                                        const GValue * param_values,
                                                                        gpointer invocation_hint,
                                                                        gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__ENUM_BOOLEAN (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void game_finalize (GObject * obj);
static GType game_get_type_once (void);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
game_type_to_string (GameType self)
{
	gchar* result;
#line 28 "../src/taquin-game.vala"
	switch (self) {
#line 28 "../src/taquin-game.vala"
		case GAME_TYPE_FIFTEEN:
#line 218 "taquin-game.c"
		{
			gchar* _tmp0_;
#line 30 "../src/taquin-game.vala"
			_tmp0_ = g_strdup ("fifteen");
#line 30 "../src/taquin-game.vala"
			result = _tmp0_;
#line 30 "../src/taquin-game.vala"
			return result;
#line 227 "taquin-game.c"
		}
#line 28 "../src/taquin-game.vala"
		case GAME_TYPE_SIXTEEN:
#line 231 "taquin-game.c"
		{
			gchar* _tmp1_;
#line 31 "../src/taquin-game.vala"
			_tmp1_ = g_strdup ("sixteen");
#line 31 "../src/taquin-game.vala"
			result = _tmp1_;
#line 31 "../src/taquin-game.vala"
			return result;
#line 240 "taquin-game.c"
		}
		default:
		{
#line 32 "../src/taquin-game.vala"
			g_assert_not_reached ();
#line 246 "taquin-game.c"
		}
	}
}

static GType
game_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_TYPE_FIFTEEN, "GAME_TYPE_FIFTEEN", "fifteen"}, {GAME_TYPE_SIXTEEN, "GAME_TYPE_SIXTEEN", "sixteen"}, {0, NULL, NULL}};
	GType game_type_type_id;
	game_type_type_id = g_enum_register_static ("GameType", values);
	return game_type_type_id;
}

GType
game_type_get_type (void)
{
	static volatile gsize game_type_type_id__once = 0;
	if (g_once_init_enter (&game_type_type_id__once)) {
		GType game_type_type_id;
		game_type_type_id = game_type_get_type_once ();
		g_once_init_leave (&game_type_type_id__once, game_type_type_id);
	}
	return game_type_type_id__once;
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

static GType
game_bad_click_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_BAD_CLICK_EMPTY_TILE, "GAME_BAD_CLICK_EMPTY_TILE", "empty-tile"}, {GAME_BAD_CLICK_NOT_MOVING, "GAME_BAD_CLICK_NOT_MOVING", "not-moving"}, {GAME_BAD_CLICK_IS_OUTSIDE, "GAME_BAD_CLICK_IS_OUTSIDE", "is-outside"}, {GAME_BAD_CLICK_USE_ARROWS, "GAME_BAD_CLICK_USE_ARROWS", "use-arrows"}, {0, NULL, NULL}};
	GType game_bad_click_type_id;
	game_bad_click_type_id = g_enum_register_static ("GameBadClick", values);
	return game_bad_click_type_id;
}

GType
game_bad_click_get_type (void)
{
	static volatile gsize game_bad_click_type_id__once = 0;
	if (g_once_init_enter (&game_bad_click_type_id__once)) {
		GType game_bad_click_type_id;
		game_bad_click_type_id = game_bad_click_get_type_once ();
		g_once_init_leave (&game_bad_click_type_id__once, game_bad_click_type_id);
	}
	return game_bad_click_type_id__once;
}

gint8
game_get_tile_value (Game* self,
                     gint8 x,
                     gint8 y)
{
	gint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint8 _tmp1_;
	gint8 result;
#line 44 "../src/taquin-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/taquin-game.vala"
	_tmp0_ = self->priv->tiles;
#line 44 "../src/taquin-game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 44 "../src/taquin-game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 44 "../src/taquin-game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 44 "../src/taquin-game.vala"
	result = _tmp1_;
#line 44 "../src/taquin-game.vala"
	return result;
#line 323 "taquin-game.c"
}

Game*
game_construct (GType object_type,
                GameType game_type,
                gint8 size)
{
	Game * self = NULL;
#line 76 "../src/taquin-game.vala"
	_vala_return_val_if_fail (((gint) size) >= 2, "size >= 2", NULL);
#line 76 "../src/taquin-game.vala"
	_vala_return_val_if_fail (((gint) size) <= 9, "size <= 9", NULL);
#line 80 "../src/taquin-game.vala"
	self = (Game*) g_object_new (object_type, "game-type", game_type, "size", size, NULL);
#line 76 "../src/taquin-game.vala"
	return self;
#line 340 "taquin-game.c"
}

Game*
game_new (GameType game_type,
          gint8 size)
{
#line 76 "../src/taquin-game.vala"
	return game_construct (TYPE_GAME, game_type, size);
#line 349 "taquin-game.c"
}

static gint8*
_int8_dup (gint8* self)
{
	gint8* dup;
#line 91 "../src/taquin-game.vala"
	dup = g_new0 (gint8, 1);
#line 91 "../src/taquin-game.vala"
	memcpy (dup, self, sizeof (gint8));
#line 91 "../src/taquin-game.vala"
	return dup;
#line 362 "taquin-game.c"
}

static gpointer
__int8_dup0 (gpointer self)
{
#line 91 "../src/taquin-game.vala"
	return self ? _int8_dup (self) : NULL;
#line 370 "taquin-game.c"
}

static void
game_generate_game (GameType game_type,
                    gint8 size,
                    gint8** tiles,
                    gint* tiles_length1,
                    gint* tiles_length2)
{
	gint8* _vala_tiles = NULL;
	gint _vala_tiles_length1 = 0;
	gint _vala_tiles_length2 = 0;
	gint8 ntiles = 0;
	gint8** line = NULL;
	gint8** _tmp0_;
	gint line_length1;
	gint _line_size_;
	gint i = 0;
	gboolean parity_grid = FALSE;
	gboolean parity_game = FALSE;
	gint8* _tmp33_;
#line 85 "../src/taquin-game.vala"
	ntiles = size * size;
#line 86 "../src/taquin-game.vala"
	_tmp0_ = g_new0 (gint8*, ntiles);
#line 86 "../src/taquin-game.vala"
	line = _tmp0_;
#line 86 "../src/taquin-game.vala"
	line_length1 = ntiles;
#line 86 "../src/taquin-game.vala"
	_line_size_ = line_length1;
#line 87 "../src/taquin-game.vala"
	i = 0;
#line 404 "taquin-game.c"
	{
		gint8 n = 0;
#line 88 "../src/taquin-game.vala"
		n = (gint8) (ntiles - 1);
#line 409 "taquin-game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 88 "../src/taquin-game.vala"
			_tmp1_ = TRUE;
#line 88 "../src/taquin-game.vala"
			while (TRUE) {
#line 416 "taquin-game.c"
				gint8** _tmp6_;
				gint _tmp6__length1;
				gint8* _tmp7_;
#line 88 "../src/taquin-game.vala"
				if (!_tmp1_) {
#line 422 "taquin-game.c"
					gint8 _tmp2_;
#line 88 "../src/taquin-game.vala"
					_tmp2_ = n;
#line 88 "../src/taquin-game.vala"
					n = _tmp2_ - 1;
#line 428 "taquin-game.c"
				}
#line 88 "../src/taquin-game.vala"
				_tmp1_ = FALSE;
#line 88 "../src/taquin-game.vala"
				if (!(((gint) n) >= 0)) {
#line 88 "../src/taquin-game.vala"
					break;
#line 436 "taquin-game.c"
				}
				{
					gboolean _tmp3_ = FALSE;
#line 90 "../src/taquin-game.vala"
					_tmp3_ = TRUE;
#line 90 "../src/taquin-game.vala"
					while (TRUE) {
#line 90 "../src/taquin-game.vala"
						if (!_tmp3_) {
#line 446 "taquin-game.c"
							gint8** _tmp4_;
							gint _tmp4__length1;
							gint8* _tmp5_;
#line 90 "../src/taquin-game.vala"
							_tmp4_ = line;
#line 90 "../src/taquin-game.vala"
							_tmp4__length1 = line_length1;
#line 90 "../src/taquin-game.vala"
							_tmp5_ = _tmp4_[i];
#line 90 "../src/taquin-game.vala"
							if (!(_tmp5_ != NULL)) {
#line 90 "../src/taquin-game.vala"
								break;
#line 460 "taquin-game.c"
							}
						}
#line 90 "../src/taquin-game.vala"
						_tmp3_ = FALSE;
#line 90 "../src/taquin-game.vala"
						i = (gint) g_random_int_range ((gint32) 0, (gint32) ((gint) ntiles));
#line 467 "taquin-game.c"
					}
				}
#line 91 "../src/taquin-game.vala"
				_tmp6_ = line;
#line 91 "../src/taquin-game.vala"
				_tmp6__length1 = line_length1;
#line 91 "../src/taquin-game.vala"
				_tmp7_ = __int8_dup0 (&n);
#line 91 "../src/taquin-game.vala"
				_g_free0 (_tmp6_[i]);
#line 91 "../src/taquin-game.vala"
				_tmp6_[i] = _tmp7_;
#line 480 "taquin-game.c"
			}
		}
	}
#line 94 "../src/taquin-game.vala"
	if (game_type == GAME_TYPE_FIFTEEN) {
#line 486 "taquin-game.c"
		gint8** _tmp8_;
		gint _tmp8__length1;
		gint8** _tmp9_;
		gint _tmp9__length1;
		gint8* _tmp10_;
		gint8* _tmp11_;
		gint8** _tmp12_;
		gint _tmp12__length1;
		gint8 _tmp13_;
		gint8* _tmp14_;
#line 97 "../src/taquin-game.vala"
		_tmp8_ = line;
#line 97 "../src/taquin-game.vala"
		_tmp8__length1 = line_length1;
#line 97 "../src/taquin-game.vala"
		_tmp9_ = line;
#line 97 "../src/taquin-game.vala"
		_tmp9__length1 = line_length1;
#line 97 "../src/taquin-game.vala"
		_tmp10_ = _tmp9_[0];
#line 97 "../src/taquin-game.vala"
		_tmp11_ = __int8_dup0 (_tmp10_);
#line 97 "../src/taquin-game.vala"
		_g_free0 (_tmp8_[i]);
#line 97 "../src/taquin-game.vala"
		_tmp8_[i] = _tmp11_;
#line 98 "../src/taquin-game.vala"
		_tmp12_ = line;
#line 98 "../src/taquin-game.vala"
		_tmp12__length1 = line_length1;
#line 98 "../src/taquin-game.vala"
		_tmp13_ = (gint8) -1;
#line 98 "../src/taquin-game.vala"
		_tmp14_ = __int8_dup0 (&_tmp13_);
#line 98 "../src/taquin-game.vala"
		_g_free0 (_tmp12_[0]);
#line 98 "../src/taquin-game.vala"
		_tmp12_[0] = _tmp14_;
#line 525 "taquin-game.c"
	}
#line 102 "../src/taquin-game.vala"
	parity_grid = ((gboolean) ((size % 2) ^ (size % 2))) & (1 == 0);
#line 103 "../src/taquin-game.vala"
	parity_game = FALSE;
#line 531 "taquin-game.c"
	{
		guint8 j = 0U;
#line 104 "../src/taquin-game.vala"
		j = (guint8) 0;
#line 536 "taquin-game.c"
		{
			gboolean _tmp15_ = FALSE;
#line 104 "../src/taquin-game.vala"
			_tmp15_ = TRUE;
#line 104 "../src/taquin-game.vala"
			while (TRUE) {
#line 104 "../src/taquin-game.vala"
				if (!_tmp15_) {
#line 545 "taquin-game.c"
					guint8 _tmp16_;
#line 104 "../src/taquin-game.vala"
					_tmp16_ = j;
#line 104 "../src/taquin-game.vala"
					j = _tmp16_ + 1;
#line 551 "taquin-game.c"
				}
#line 104 "../src/taquin-game.vala"
				_tmp15_ = FALSE;
#line 104 "../src/taquin-game.vala"
				if (!(((gint) j) < (ntiles - 1))) {
#line 104 "../src/taquin-game.vala"
					break;
#line 559 "taquin-game.c"
				}
				{
					guint8 k = 0U;
#line 105 "../src/taquin-game.vala"
					k = (guint8) (j + 1);
#line 565 "taquin-game.c"
					{
						gboolean _tmp17_ = FALSE;
#line 105 "../src/taquin-game.vala"
						_tmp17_ = TRUE;
#line 105 "../src/taquin-game.vala"
						while (TRUE) {
#line 572 "taquin-game.c"
							gint8** _tmp19_;
							gint _tmp19__length1;
							gint8* _tmp20_;
							gint8** _tmp21_;
							gint _tmp21__length1;
							gint8* _tmp22_;
#line 105 "../src/taquin-game.vala"
							if (!_tmp17_) {
#line 581 "taquin-game.c"
								guint8 _tmp18_;
#line 105 "../src/taquin-game.vala"
								_tmp18_ = k;
#line 105 "../src/taquin-game.vala"
								k = _tmp18_ + 1;
#line 587 "taquin-game.c"
							}
#line 105 "../src/taquin-game.vala"
							_tmp17_ = FALSE;
#line 105 "../src/taquin-game.vala"
							if (!(k < ((guint8) ntiles))) {
#line 105 "../src/taquin-game.vala"
								break;
#line 595 "taquin-game.c"
							}
#line 106 "../src/taquin-game.vala"
							_tmp19_ = line;
#line 106 "../src/taquin-game.vala"
							_tmp19__length1 = line_length1;
#line 106 "../src/taquin-game.vala"
							_tmp20_ = _tmp19_[j];
#line 106 "../src/taquin-game.vala"
							_tmp21_ = line;
#line 106 "../src/taquin-game.vala"
							_tmp21__length1 = line_length1;
#line 106 "../src/taquin-game.vala"
							_tmp22_ = _tmp21_[k];
#line 106 "../src/taquin-game.vala"
							if ((*_tmp20_) > (*_tmp22_)) {
#line 107 "../src/taquin-game.vala"
								parity_game = !parity_game;
#line 613 "taquin-game.c"
							}
						}
					}
				}
			}
		}
	}
#line 109 "../src/taquin-game.vala"
	if (parity_game != parity_grid) {
#line 623 "taquin-game.c"
		gint8* save = NULL;
		gint8** _tmp23_;
		gint _tmp23__length1;
		gint8* _tmp24_;
		gint8* _tmp25_;
		gint8** _tmp26_;
		gint _tmp26__length1;
		gint8** _tmp27_;
		gint _tmp27__length1;
		gint8* _tmp28_;
		gint8* _tmp29_;
		gint8** _tmp30_;
		gint _tmp30__length1;
		gint8* _tmp31_;
		gint8* _tmp32_;
#line 111 "../src/taquin-game.vala"
		_tmp23_ = line;
#line 111 "../src/taquin-game.vala"
		_tmp23__length1 = line_length1;
#line 111 "../src/taquin-game.vala"
		_tmp24_ = _tmp23_[1];
#line 111 "../src/taquin-game.vala"
		_tmp25_ = __int8_dup0 (_tmp24_);
#line 111 "../src/taquin-game.vala"
		save = _tmp25_;
#line 112 "../src/taquin-game.vala"
		_tmp26_ = line;
#line 112 "../src/taquin-game.vala"
		_tmp26__length1 = line_length1;
#line 112 "../src/taquin-game.vala"
		_tmp27_ = line;
#line 112 "../src/taquin-game.vala"
		_tmp27__length1 = line_length1;
#line 112 "../src/taquin-game.vala"
		_tmp28_ = _tmp27_[size + 1];
#line 112 "../src/taquin-game.vala"
		_tmp29_ = __int8_dup0 (_tmp28_);
#line 112 "../src/taquin-game.vala"
		_g_free0 (_tmp26_[1]);
#line 112 "../src/taquin-game.vala"
		_tmp26_[1] = _tmp29_;
#line 113 "../src/taquin-game.vala"
		_tmp30_ = line;
#line 113 "../src/taquin-game.vala"
		_tmp30__length1 = line_length1;
#line 113 "../src/taquin-game.vala"
		_tmp31_ = save;
#line 113 "../src/taquin-game.vala"
		_tmp32_ = __int8_dup0 (_tmp31_);
#line 113 "../src/taquin-game.vala"
		_g_free0 (_tmp30_[size + 1]);
#line 113 "../src/taquin-game.vala"
		_tmp30_[size + 1] = _tmp32_;
#line 109 "../src/taquin-game.vala"
		_g_free0 (save);
#line 679 "taquin-game.c"
	}
#line 117 "../src/taquin-game.vala"
	_tmp33_ = g_new0 (gint8, size * size);
#line 117 "../src/taquin-game.vala"
	_vala_tiles = (g_free (_vala_tiles), NULL);
#line 117 "../src/taquin-game.vala"
	_vala_tiles = _tmp33_;
#line 117 "../src/taquin-game.vala"
	_vala_tiles_length1 = size;
#line 117 "../src/taquin-game.vala"
	_vala_tiles_length2 = size;
#line 691 "taquin-game.c"
	{
		guint8 j = 0U;
#line 119 "../src/taquin-game.vala"
		j = (guint8) 0;
#line 696 "taquin-game.c"
		{
			gboolean _tmp34_ = FALSE;
#line 119 "../src/taquin-game.vala"
			_tmp34_ = TRUE;
#line 119 "../src/taquin-game.vala"
			while (TRUE) {
#line 703 "taquin-game.c"
				gint8* line_j = NULL;
				gint8** _tmp36_;
				gint _tmp36__length1;
				gint8* _tmp37_;
				gint8* _tmp38_;
				gint8* _tmp39_;
				gint8* _tmp40_;
				gint _tmp40__length1;
				gint _tmp40__length2;
				gint8* _tmp41_;
#line 119 "../src/taquin-game.vala"
				if (!_tmp34_) {
#line 716 "taquin-game.c"
					guint8 _tmp35_;
#line 119 "../src/taquin-game.vala"
					_tmp35_ = j;
#line 119 "../src/taquin-game.vala"
					j = _tmp35_ + 1;
#line 722 "taquin-game.c"
				}
#line 119 "../src/taquin-game.vala"
				_tmp34_ = FALSE;
#line 119 "../src/taquin-game.vala"
				if (!(j < ((guint8) ntiles))) {
#line 119 "../src/taquin-game.vala"
					break;
#line 730 "taquin-game.c"
				}
#line 121 "../src/taquin-game.vala"
				_tmp36_ = line;
#line 121 "../src/taquin-game.vala"
				_tmp36__length1 = line_length1;
#line 121 "../src/taquin-game.vala"
				_tmp37_ = _tmp36_[j];
#line 121 "../src/taquin-game.vala"
				_tmp38_ = __int8_dup0 (_tmp37_);
#line 121 "../src/taquin-game.vala"
				line_j = _tmp38_;
#line 122 "../src/taquin-game.vala"
				_tmp39_ = line_j;
#line 122 "../src/taquin-game.vala"
				if (_tmp39_ == NULL) {
#line 123 "../src/taquin-game.vala"
					g_assert_not_reached ();
#line 748 "taquin-game.c"
				}
#line 124 "../src/taquin-game.vala"
				_tmp40_ = _vala_tiles;
#line 124 "../src/taquin-game.vala"
				_tmp40__length1 = _vala_tiles_length1;
#line 124 "../src/taquin-game.vala"
				_tmp40__length2 = _vala_tiles_length2;
#line 124 "../src/taquin-game.vala"
				_tmp41_ = line_j;
#line 124 "../src/taquin-game.vala"
				_tmp40_[((j % size) * _tmp40__length2) + (j / size)] = (gint8) (*_tmp41_);
#line 119 "../src/taquin-game.vala"
				_g_free0 (line_j);
#line 762 "taquin-game.c"
			}
		}
	}
#line 83 "../src/taquin-game.vala"
	line = (_vala_array_free (line, line_length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/taquin-game.vala"
	if (tiles) {
#line 83 "../src/taquin-game.vala"
		*tiles = _vala_tiles;
#line 772 "taquin-game.c"
	} else {
#line 83 "../src/taquin-game.vala"
		_vala_tiles = (g_free (_vala_tiles), NULL);
#line 776 "taquin-game.c"
	}
#line 83 "../src/taquin-game.vala"
	if (tiles_length1) {
#line 83 "../src/taquin-game.vala"
		*tiles_length1 = _vala_tiles_length1;
#line 782 "taquin-game.c"
	}
#line 83 "../src/taquin-game.vala"
	if (tiles_length2) {
#line 83 "../src/taquin-game.vala"
		*tiles_length2 = _vala_tiles_length2;
#line 788 "taquin-game.c"
	}
}

gchar*
game_to_string (Game* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 128 "../src/taquin-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "../src/taquin-game.vala"
	_tmp0_ = g_strdup ("\n");
#line 130 "../src/taquin-game.vala"
	s = _tmp0_;
#line 804 "taquin-game.c"
	{
		guint8 x = 0U;
#line 132 "../src/taquin-game.vala"
		x = (guint8) 0;
#line 809 "taquin-game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 132 "../src/taquin-game.vala"
			_tmp1_ = TRUE;
#line 132 "../src/taquin-game.vala"
			while (TRUE) {
#line 816 "taquin-game.c"
				gint8 _tmp3_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 132 "../src/taquin-game.vala"
				if (!_tmp1_) {
#line 822 "taquin-game.c"
					guint8 _tmp2_;
#line 132 "../src/taquin-game.vala"
					_tmp2_ = x;
#line 132 "../src/taquin-game.vala"
					x = _tmp2_ + 1;
#line 828 "taquin-game.c"
				}
#line 132 "../src/taquin-game.vala"
				_tmp1_ = FALSE;
#line 132 "../src/taquin-game.vala"
				_tmp3_ = self->priv->_size;
#line 132 "../src/taquin-game.vala"
				if (!(x < ((guint8) _tmp3_))) {
#line 132 "../src/taquin-game.vala"
					break;
#line 838 "taquin-game.c"
				}
				{
					guint8 y = 0U;
#line 134 "../src/taquin-game.vala"
					y = (guint8) 0;
#line 844 "taquin-game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 134 "../src/taquin-game.vala"
						_tmp4_ = TRUE;
#line 134 "../src/taquin-game.vala"
						while (TRUE) {
#line 851 "taquin-game.c"
							gint8 _tmp6_;
							const gchar* _tmp7_;
							gint8* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gint8 _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* _tmp13_;
							gchar* _tmp14_;
#line 134 "../src/taquin-game.vala"
							if (!_tmp4_) {
#line 865 "taquin-game.c"
								guint8 _tmp5_;
#line 134 "../src/taquin-game.vala"
								_tmp5_ = y;
#line 134 "../src/taquin-game.vala"
								y = _tmp5_ + 1;
#line 871 "taquin-game.c"
							}
#line 134 "../src/taquin-game.vala"
							_tmp4_ = FALSE;
#line 134 "../src/taquin-game.vala"
							_tmp6_ = self->priv->_size;
#line 134 "../src/taquin-game.vala"
							if (!(y < ((guint8) _tmp6_))) {
#line 134 "../src/taquin-game.vala"
								break;
#line 881 "taquin-game.c"
							}
#line 135 "../src/taquin-game.vala"
							_tmp7_ = s;
#line 135 "../src/taquin-game.vala"
							_tmp8_ = self->priv->tiles;
#line 135 "../src/taquin-game.vala"
							_tmp8__length1 = self->priv->tiles_length1;
#line 135 "../src/taquin-game.vala"
							_tmp8__length2 = self->priv->tiles_length2;
#line 135 "../src/taquin-game.vala"
							_tmp9_ = _tmp8_[(y * _tmp8__length2) + x];
#line 135 "../src/taquin-game.vala"
							_tmp10_ = g_strdup_printf ("%i", _tmp9_ + 1);
#line 135 "../src/taquin-game.vala"
							_tmp11_ = _tmp10_;
#line 135 "../src/taquin-game.vala"
							_tmp12_ = g_strconcat (" ", _tmp11_, NULL);
#line 135 "../src/taquin-game.vala"
							_tmp13_ = _tmp12_;
#line 135 "../src/taquin-game.vala"
							_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 135 "../src/taquin-game.vala"
							_g_free0 (s);
#line 135 "../src/taquin-game.vala"
							s = _tmp14_;
#line 135 "../src/taquin-game.vala"
							_g_free0 (_tmp13_);
#line 135 "../src/taquin-game.vala"
							_g_free0 (_tmp11_);
#line 911 "taquin-game.c"
						}
					}
				}
#line 136 "../src/taquin-game.vala"
				_tmp15_ = s;
#line 136 "../src/taquin-game.vala"
				_tmp16_ = g_strconcat (_tmp15_, "\n", NULL);
#line 136 "../src/taquin-game.vala"
				_g_free0 (s);
#line 136 "../src/taquin-game.vala"
				s = _tmp16_;
#line 923 "taquin-game.c"
			}
		}
	}
#line 139 "../src/taquin-game.vala"
	result = s;
#line 139 "../src/taquin-game.vala"
	return result;
#line 931 "taquin-game.c"
}

void
game_request_move (Game* self,
                   gint8 x,
                   gint8 y,
                   gboolean keyboard_call)
{
	GameType _tmp0_;
#line 146 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/taquin-game.vala"
	_tmp0_ = self->priv->_game_type;
#line 148 "../src/taquin-game.vala"
	if (_tmp0_ == GAME_TYPE_FIFTEEN) {
#line 947 "taquin-game.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
#line 150 "../src/taquin-game.vala"
		if (((gint) x) < 0) {
#line 150 "../src/taquin-game.vala"
			_tmp3_ = TRUE;
#line 957 "taquin-game.c"
		} else {
			gint8 _tmp4_;
#line 150 "../src/taquin-game.vala"
			_tmp4_ = self->priv->_size;
#line 150 "../src/taquin-game.vala"
			_tmp3_ = x >= _tmp4_;
#line 964 "taquin-game.c"
		}
#line 150 "../src/taquin-game.vala"
		if (_tmp3_) {
#line 150 "../src/taquin-game.vala"
			_tmp2_ = TRUE;
#line 970 "taquin-game.c"
		} else {
#line 150 "../src/taquin-game.vala"
			_tmp2_ = ((gint) y) < 0;
#line 974 "taquin-game.c"
		}
#line 150 "../src/taquin-game.vala"
		if (_tmp2_) {
#line 150 "../src/taquin-game.vala"
			_tmp1_ = TRUE;
#line 980 "taquin-game.c"
		} else {
			gint8 _tmp5_;
#line 150 "../src/taquin-game.vala"
			_tmp5_ = self->priv->_size;
#line 150 "../src/taquin-game.vala"
			_tmp1_ = y >= _tmp5_;
#line 987 "taquin-game.c"
		}
#line 150 "../src/taquin-game.vala"
		if (_tmp1_) {
#line 152 "../src/taquin-game.vala"
			g_signal_emit (self, game_signals[GAME_BAD_CLICK_SIGNAL], 0, GAME_BAD_CLICK_IS_OUTSIDE, keyboard_call);
#line 153 "../src/taquin-game.vala"
			return;
#line 995 "taquin-game.c"
		}
#line 155 "../src/taquin-game.vala"
		if (x == self->priv->x_gap) {
#line 155 "../src/taquin-game.vala"
			_tmp6_ = y == self->priv->y_gap;
#line 1001 "taquin-game.c"
		} else {
#line 155 "../src/taquin-game.vala"
			_tmp6_ = FALSE;
#line 1005 "taquin-game.c"
		}
#line 155 "../src/taquin-game.vala"
		if (_tmp6_) {
#line 157 "../src/taquin-game.vala"
			g_signal_emit (self, game_signals[GAME_BAD_CLICK_SIGNAL], 0, GAME_BAD_CLICK_EMPTY_TILE, keyboard_call);
#line 158 "../src/taquin-game.vala"
			return;
#line 1013 "taquin-game.c"
		}
#line 160 "../src/taquin-game.vala"
		if (x != self->priv->x_gap) {
#line 160 "../src/taquin-game.vala"
			_tmp7_ = y != self->priv->y_gap;
#line 1019 "taquin-game.c"
		} else {
#line 160 "../src/taquin-game.vala"
			_tmp7_ = FALSE;
#line 1023 "taquin-game.c"
		}
#line 160 "../src/taquin-game.vala"
		if (_tmp7_) {
#line 162 "../src/taquin-game.vala"
			g_signal_emit (self, game_signals[GAME_BAD_CLICK_SIGNAL], 0, GAME_BAD_CLICK_NOT_MOVING, keyboard_call);
#line 163 "../src/taquin-game.vala"
			return;
#line 1031 "taquin-game.c"
		}
#line 165 "../src/taquin-game.vala"
		game_fifteen_move (self, x, y, FALSE, FALSE);
#line 1035 "taquin-game.c"
	} else {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
#line 170 "../src/taquin-game.vala"
		if (((gint) x) >= 0) {
#line 1042 "taquin-game.c"
			gint8 _tmp11_;
#line 170 "../src/taquin-game.vala"
			_tmp11_ = self->priv->_size;
#line 170 "../src/taquin-game.vala"
			_tmp10_ = x < _tmp11_;
#line 1048 "taquin-game.c"
		} else {
#line 170 "../src/taquin-game.vala"
			_tmp10_ = FALSE;
#line 1052 "taquin-game.c"
		}
#line 170 "../src/taquin-game.vala"
		if (_tmp10_) {
#line 170 "../src/taquin-game.vala"
			_tmp9_ = ((gint) y) >= 0;
#line 1058 "taquin-game.c"
		} else {
#line 170 "../src/taquin-game.vala"
			_tmp9_ = FALSE;
#line 1062 "taquin-game.c"
		}
#line 170 "../src/taquin-game.vala"
		if (_tmp9_) {
#line 1066 "taquin-game.c"
			gint8 _tmp12_;
#line 170 "../src/taquin-game.vala"
			_tmp12_ = self->priv->_size;
#line 170 "../src/taquin-game.vala"
			_tmp8_ = y < _tmp12_;
#line 1072 "taquin-game.c"
		} else {
#line 170 "../src/taquin-game.vala"
			_tmp8_ = FALSE;
#line 1076 "taquin-game.c"
		}
#line 170 "../src/taquin-game.vala"
		if (_tmp8_) {
#line 172 "../src/taquin-game.vala"
			g_signal_emit (self, game_signals[GAME_BAD_CLICK_SIGNAL], 0, GAME_BAD_CLICK_USE_ARROWS, keyboard_call);
#line 173 "../src/taquin-game.vala"
			return;
#line 1084 "taquin-game.c"
		}
#line 175 "../src/taquin-game.vala"
		game_sixteen_move (self, x, y, FALSE, FALSE);
#line 1088 "taquin-game.c"
	}
}

static void
game_fifteen_move (Game* self,
                   gint8 x,
                   gint8 y,
                   gboolean undoing,
                   gboolean restarting)
{
	gint8 _tmp0_;
	gint8 _tmp1_;
	gboolean was_complete = FALSE;
	gboolean _tmp2_;
	gboolean move_x_axis = FALSE;
	gint8 _tmp3_ = 0;
	gint8 move_number = 0;
	gint8* _tmp26_;
	gint _tmp26__length1;
	gint _tmp26__length2;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp29_;
#line 179 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/taquin-game.vala"
	_vala_return_if_fail ((!restarting) || undoing, "!restarting || undoing");
#line 179 "../src/taquin-game.vala"
	_tmp0_ = self->priv->_size;
#line 179 "../src/taquin-game.vala"
	_vala_return_if_fail ((((gint) x) >= 0) && (x < _tmp0_), "(x >= 0) && (x < size)");
#line 179 "../src/taquin-game.vala"
	_tmp1_ = self->priv->_size;
#line 179 "../src/taquin-game.vala"
	_vala_return_if_fail ((((gint) y) >= 0) && (y < _tmp1_), "(y >= 0) && (y < size)");
#line 185 "../src/taquin-game.vala"
	_tmp2_ = game_check_complete (&self->priv->tiles, (gint*) (&self->priv->tiles_length1), (gint*) (&self->priv->tiles_length2));
#line 185 "../src/taquin-game.vala"
	was_complete = _tmp2_;
#line 187 "../src/taquin-game.vala"
	move_x_axis = x != self->priv->x_gap;
#line 188 "../src/taquin-game.vala"
	if (move_x_axis) {
#line 188 "../src/taquin-game.vala"
		_tmp3_ = self->priv->x_gap - x;
#line 1133 "taquin-game.c"
	} else {
#line 188 "../src/taquin-game.vala"
		_tmp3_ = self->priv->y_gap - y;
#line 1137 "taquin-game.c"
	}
#line 188 "../src/taquin-game.vala"
	move_number = _tmp3_;
#line 190 "../src/taquin-game.vala"
	if (undoing) {
#line 192 "../src/taquin-game.vala"
		if (self->priv->moves_count == ((guint) 0)) {
#line 193 "../src/taquin-game.vala"
			g_assert_not_reached ();
#line 1147 "taquin-game.c"
		}
#line 194 "../src/taquin-game.vala"
		if (self->priv->moves_count != G_MAXUINT) {
#line 1151 "taquin-game.c"
			guint _tmp4_;
#line 195 "../src/taquin-game.vala"
			_tmp4_ = self->priv->moves_count;
#line 195 "../src/taquin-game.vala"
			self->priv->moves_count = _tmp4_ - 1;
#line 1157 "taquin-game.c"
		}
	} else {
#line 199 "../src/taquin-game.vala"
		game_add_move (self, self->priv->x_gap, self->priv->y_gap);
#line 200 "../src/taquin-game.vala"
		if (self->priv->moves_count != G_MAXUINT) {
#line 1164 "taquin-game.c"
			guint _tmp5_;
#line 201 "../src/taquin-game.vala"
			_tmp5_ = self->priv->moves_count;
#line 201 "../src/taquin-game.vala"
			self->priv->moves_count = _tmp5_ + 1;
#line 1170 "taquin-game.c"
		}
	}
#line 204 "../src/taquin-game.vala"
	if (move_x_axis) {
#line 206 "../src/taquin-game.vala"
		if (x < self->priv->x_gap) {
#line 1177 "taquin-game.c"
			{
				gboolean _tmp6_ = FALSE;
#line 207 "../src/taquin-game.vala"
				_tmp6_ = TRUE;
#line 207 "../src/taquin-game.vala"
				while (TRUE) {
#line 1184 "taquin-game.c"
					gint8* _tmp7_;
					gint _tmp7__length1;
					gint _tmp7__length2;
					gint8* _tmp8_;
					gint _tmp8__length1;
					gint _tmp8__length2;
					gint8 _tmp9_;
					gint8 _tmp10_;
#line 207 "../src/taquin-game.vala"
					if (!_tmp6_) {
#line 207 "../src/taquin-game.vala"
						if (!(self->priv->x_gap != x)) {
#line 207 "../src/taquin-game.vala"
							break;
#line 1199 "taquin-game.c"
						}
					}
#line 207 "../src/taquin-game.vala"
					_tmp6_ = FALSE;
#line 207 "../src/taquin-game.vala"
					_tmp7_ = self->priv->tiles;
#line 207 "../src/taquin-game.vala"
					_tmp7__length1 = self->priv->tiles_length1;
#line 207 "../src/taquin-game.vala"
					_tmp7__length2 = self->priv->tiles_length2;
#line 207 "../src/taquin-game.vala"
					_tmp8_ = self->priv->tiles;
#line 207 "../src/taquin-game.vala"
					_tmp8__length1 = self->priv->tiles_length1;
#line 207 "../src/taquin-game.vala"
					_tmp8__length2 = self->priv->tiles_length2;
#line 207 "../src/taquin-game.vala"
					_tmp9_ = _tmp8_[((self->priv->x_gap - 1) * _tmp8__length2) + y];
#line 207 "../src/taquin-game.vala"
					_tmp7_[(self->priv->x_gap * _tmp7__length2) + y] = _tmp9_;
#line 207 "../src/taquin-game.vala"
					_tmp10_ = self->priv->x_gap;
#line 207 "../src/taquin-game.vala"
					self->priv->x_gap = _tmp10_ - 1;
#line 1224 "taquin-game.c"
				}
			}
		} else {
			{
				gboolean _tmp11_ = FALSE;
#line 209 "../src/taquin-game.vala"
				_tmp11_ = TRUE;
#line 209 "../src/taquin-game.vala"
				while (TRUE) {
#line 1234 "taquin-game.c"
					gint8* _tmp12_;
					gint _tmp12__length1;
					gint _tmp12__length2;
					gint8* _tmp13_;
					gint _tmp13__length1;
					gint _tmp13__length2;
					gint8 _tmp14_;
					gint8 _tmp15_;
#line 209 "../src/taquin-game.vala"
					if (!_tmp11_) {
#line 209 "../src/taquin-game.vala"
						if (!(self->priv->x_gap != x)) {
#line 209 "../src/taquin-game.vala"
							break;
#line 1249 "taquin-game.c"
						}
					}
#line 209 "../src/taquin-game.vala"
					_tmp11_ = FALSE;
#line 209 "../src/taquin-game.vala"
					_tmp12_ = self->priv->tiles;
#line 209 "../src/taquin-game.vala"
					_tmp12__length1 = self->priv->tiles_length1;
#line 209 "../src/taquin-game.vala"
					_tmp12__length2 = self->priv->tiles_length2;
#line 209 "../src/taquin-game.vala"
					_tmp13_ = self->priv->tiles;
#line 209 "../src/taquin-game.vala"
					_tmp13__length1 = self->priv->tiles_length1;
#line 209 "../src/taquin-game.vala"
					_tmp13__length2 = self->priv->tiles_length2;
#line 209 "../src/taquin-game.vala"
					_tmp14_ = _tmp13_[((self->priv->x_gap + 1) * _tmp13__length2) + y];
#line 209 "../src/taquin-game.vala"
					_tmp12_[(self->priv->x_gap * _tmp12__length2) + y] = _tmp14_;
#line 209 "../src/taquin-game.vala"
					_tmp15_ = self->priv->x_gap;
#line 209 "../src/taquin-game.vala"
					self->priv->x_gap = _tmp15_ + 1;
#line 1274 "taquin-game.c"
				}
			}
		}
	} else {
#line 213 "../src/taquin-game.vala"
		if (y < self->priv->y_gap) {
#line 1281 "taquin-game.c"
			{
				gboolean _tmp16_ = FALSE;
#line 214 "../src/taquin-game.vala"
				_tmp16_ = TRUE;
#line 214 "../src/taquin-game.vala"
				while (TRUE) {
#line 1288 "taquin-game.c"
					gint8* _tmp17_;
					gint _tmp17__length1;
					gint _tmp17__length2;
					gint8* _tmp18_;
					gint _tmp18__length1;
					gint _tmp18__length2;
					gint8 _tmp19_;
					gint8 _tmp20_;
#line 214 "../src/taquin-game.vala"
					if (!_tmp16_) {
#line 214 "../src/taquin-game.vala"
						if (!(self->priv->y_gap != y)) {
#line 214 "../src/taquin-game.vala"
							break;
#line 1303 "taquin-game.c"
						}
					}
#line 214 "../src/taquin-game.vala"
					_tmp16_ = FALSE;
#line 214 "../src/taquin-game.vala"
					_tmp17_ = self->priv->tiles;
#line 214 "../src/taquin-game.vala"
					_tmp17__length1 = self->priv->tiles_length1;
#line 214 "../src/taquin-game.vala"
					_tmp17__length2 = self->priv->tiles_length2;
#line 214 "../src/taquin-game.vala"
					_tmp18_ = self->priv->tiles;
#line 214 "../src/taquin-game.vala"
					_tmp18__length1 = self->priv->tiles_length1;
#line 214 "../src/taquin-game.vala"
					_tmp18__length2 = self->priv->tiles_length2;
#line 214 "../src/taquin-game.vala"
					_tmp19_ = _tmp18_[(x * _tmp18__length2) + (self->priv->y_gap - 1)];
#line 214 "../src/taquin-game.vala"
					_tmp17_[(x * _tmp17__length2) + self->priv->y_gap] = _tmp19_;
#line 214 "../src/taquin-game.vala"
					_tmp20_ = self->priv->y_gap;
#line 214 "../src/taquin-game.vala"
					self->priv->y_gap = _tmp20_ - 1;
#line 1328 "taquin-game.c"
				}
			}
		} else {
			{
				gboolean _tmp21_ = FALSE;
#line 216 "../src/taquin-game.vala"
				_tmp21_ = TRUE;
#line 216 "../src/taquin-game.vala"
				while (TRUE) {
#line 1338 "taquin-game.c"
					gint8* _tmp22_;
					gint _tmp22__length1;
					gint _tmp22__length2;
					gint8* _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
					gint8 _tmp24_;
					gint8 _tmp25_;
#line 216 "../src/taquin-game.vala"
					if (!_tmp21_) {
#line 216 "../src/taquin-game.vala"
						if (!(self->priv->y_gap != y)) {
#line 216 "../src/taquin-game.vala"
							break;
#line 1353 "taquin-game.c"
						}
					}
#line 216 "../src/taquin-game.vala"
					_tmp21_ = FALSE;
#line 216 "../src/taquin-game.vala"
					_tmp22_ = self->priv->tiles;
#line 216 "../src/taquin-game.vala"
					_tmp22__length1 = self->priv->tiles_length1;
#line 216 "../src/taquin-game.vala"
					_tmp22__length2 = self->priv->tiles_length2;
#line 216 "../src/taquin-game.vala"
					_tmp23_ = self->priv->tiles;
#line 216 "../src/taquin-game.vala"
					_tmp23__length1 = self->priv->tiles_length1;
#line 216 "../src/taquin-game.vala"
					_tmp23__length2 = self->priv->tiles_length2;
#line 216 "../src/taquin-game.vala"
					_tmp24_ = _tmp23_[(x * _tmp23__length2) + (self->priv->y_gap + 1)];
#line 216 "../src/taquin-game.vala"
					_tmp22_[(x * _tmp22__length2) + self->priv->y_gap] = _tmp24_;
#line 216 "../src/taquin-game.vala"
					_tmp25_ = self->priv->y_gap;
#line 216 "../src/taquin-game.vala"
					self->priv->y_gap = _tmp25_ + 1;
#line 1378 "taquin-game.c"
				}
			}
		}
	}
#line 218 "../src/taquin-game.vala"
	_tmp26_ = self->priv->tiles;
#line 218 "../src/taquin-game.vala"
	_tmp26__length1 = self->priv->tiles_length1;
#line 218 "../src/taquin-game.vala"
	_tmp26__length2 = self->priv->tiles_length2;
#line 218 "../src/taquin-game.vala"
	_tmp26_[(self->priv->x_gap * _tmp26__length2) + self->priv->y_gap] = (gint8) -1;
#line 220 "../src/taquin-game.vala"
	if (restarting) {
#line 220 "../src/taquin-game.vala"
		_tmp27_ = TRUE;
#line 1395 "taquin-game.c"
	} else {
		gboolean _tmp28_ = FALSE;
#line 220 "../src/taquin-game.vala"
		if (was_complete) {
#line 220 "../src/taquin-game.vala"
			_tmp28_ = undoing;
#line 1402 "taquin-game.c"
		} else {
#line 220 "../src/taquin-game.vala"
			_tmp28_ = FALSE;
#line 1406 "taquin-game.c"
		}
#line 220 "../src/taquin-game.vala"
		_tmp27_ = _tmp28_;
#line 1410 "taquin-game.c"
	}
#line 220 "../src/taquin-game.vala"
	g_signal_emit (self, game_signals[GAME_MOVE_SIGNAL], 0, move_x_axis, move_number, self->priv->x_gap, self->priv->y_gap, self->priv->moves_count, _tmp27_);
#line 221 "../src/taquin-game.vala"
	_tmp29_ = game_check_complete (&self->priv->tiles, (gint*) (&self->priv->tiles_length1), (gint*) (&self->priv->tiles_length2));
#line 221 "../src/taquin-game.vala"
	if (_tmp29_) {
#line 222 "../src/taquin-game.vala"
		g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
#line 1420 "taquin-game.c"
	}
}

static void
game_sixteen_move (Game* self,
                   gint8 x,
                   gint8 y,
                   gboolean undoing,
                   gboolean restarting)
{
	gint8 _tmp0_;
	gint8 _tmp1_;
	gboolean move_x_axis = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean was_complete = FALSE;
	gboolean _tmp8_;
	gint8 new_coord = 0;
	gint _tmp59_ = 0;
	gint8 _tmp62_ = 0;
	gint8 _tmp63_ = 0;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp66_;
#line 225 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/taquin-game.vala"
	_vala_return_if_fail ((!restarting) || undoing, "!restarting || undoing");
#line 225 "../src/taquin-game.vala"
	_tmp0_ = self->priv->_size;
#line 225 "../src/taquin-game.vala"
	_tmp1_ = self->priv->_size;
#line 225 "../src/taquin-game.vala"
	_vala_return_if_fail ((((((gint) x) < 0) || (x >= _tmp0_)) || (((gint) y) < 0)) || (y >= _tmp1_), "(x < 0) || (x >= size) || (y < 0) || (y >= size)");
#line 230 "../src/taquin-game.vala"
	if (((gint) x) < 0) {
#line 230 "../src/taquin-game.vala"
		_tmp2_ = TRUE;
#line 1457 "taquin-game.c"
	} else {
		gint8 _tmp3_;
#line 230 "../src/taquin-game.vala"
		_tmp3_ = self->priv->_size;
#line 230 "../src/taquin-game.vala"
		_tmp2_ = x >= _tmp3_;
#line 1464 "taquin-game.c"
	}
#line 230 "../src/taquin-game.vala"
	if (_tmp2_) {
#line 1468 "taquin-game.c"
		gboolean _tmp4_ = FALSE;
#line 232 "../src/taquin-game.vala"
		if (((gint) y) < 0) {
#line 232 "../src/taquin-game.vala"
			_tmp4_ = TRUE;
#line 1474 "taquin-game.c"
		} else {
			gint8 _tmp5_;
#line 232 "../src/taquin-game.vala"
			_tmp5_ = self->priv->_size;
#line 232 "../src/taquin-game.vala"
			_tmp4_ = y >= _tmp5_;
#line 1481 "taquin-game.c"
		}
#line 232 "../src/taquin-game.vala"
		if (_tmp4_) {
#line 233 "../src/taquin-game.vala"
			return;
#line 1487 "taquin-game.c"
		}
#line 234 "../src/taquin-game.vala"
		move_x_axis = TRUE;
#line 1491 "taquin-game.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 238 "../src/taquin-game.vala"
		if (((gint) y) >= 0) {
#line 1496 "taquin-game.c"
			gint8 _tmp7_;
#line 238 "../src/taquin-game.vala"
			_tmp7_ = self->priv->_size;
#line 238 "../src/taquin-game.vala"
			_tmp6_ = y < _tmp7_;
#line 1502 "taquin-game.c"
		} else {
#line 238 "../src/taquin-game.vala"
			_tmp6_ = FALSE;
#line 1506 "taquin-game.c"
		}
#line 238 "../src/taquin-game.vala"
		if (_tmp6_) {
#line 239 "../src/taquin-game.vala"
			return;
#line 1512 "taquin-game.c"
		}
#line 240 "../src/taquin-game.vala"
		move_x_axis = FALSE;
#line 1516 "taquin-game.c"
	}
#line 244 "../src/taquin-game.vala"
	_tmp8_ = game_check_complete (&self->priv->tiles, (gint*) (&self->priv->tiles_length1), (gint*) (&self->priv->tiles_length2));
#line 244 "../src/taquin-game.vala"
	was_complete = _tmp8_;
#line 246 "../src/taquin-game.vala"
	new_coord = (gint8) 0;
#line 247 "../src/taquin-game.vala"
	if (move_x_axis) {
#line 249 "../src/taquin-game.vala"
		if (((gint) x) < 0) {
#line 1528 "taquin-game.c"
			gint8 tmp = 0;
			gint8* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint8 _tmp10_;
			gint8* _tmp17_;
			gint _tmp17__length1;
			gint _tmp17__length2;
			gint8 _tmp18_;
			gint8 _tmp19_;
#line 251 "../src/taquin-game.vala"
			_tmp9_ = self->priv->tiles;
#line 251 "../src/taquin-game.vala"
			_tmp9__length1 = self->priv->tiles_length1;
#line 251 "../src/taquin-game.vala"
			_tmp9__length2 = self->priv->tiles_length2;
#line 251 "../src/taquin-game.vala"
			_tmp10_ = _tmp9_[(0 * _tmp9__length2) + y];
#line 251 "../src/taquin-game.vala"
			tmp = _tmp10_;
#line 1549 "taquin-game.c"
			{
				guint8 i = 0U;
#line 252 "../src/taquin-game.vala"
				i = (guint8) 0;
#line 1554 "taquin-game.c"
				{
					gboolean _tmp11_ = FALSE;
#line 252 "../src/taquin-game.vala"
					_tmp11_ = TRUE;
#line 252 "../src/taquin-game.vala"
					while (TRUE) {
#line 1561 "taquin-game.c"
						gint8 _tmp13_;
						gint8* _tmp14_;
						gint _tmp14__length1;
						gint _tmp14__length2;
						gint8* _tmp15_;
						gint _tmp15__length1;
						gint _tmp15__length2;
						gint8 _tmp16_;
#line 252 "../src/taquin-game.vala"
						if (!_tmp11_) {
#line 1572 "taquin-game.c"
							guint8 _tmp12_;
#line 252 "../src/taquin-game.vala"
							_tmp12_ = i;
#line 252 "../src/taquin-game.vala"
							i = _tmp12_ + 1;
#line 1578 "taquin-game.c"
						}
#line 252 "../src/taquin-game.vala"
						_tmp11_ = FALSE;
#line 252 "../src/taquin-game.vala"
						_tmp13_ = self->priv->_size;
#line 252 "../src/taquin-game.vala"
						if (!(((gint) i) < (_tmp13_ - 1))) {
#line 252 "../src/taquin-game.vala"
							break;
#line 1588 "taquin-game.c"
						}
#line 253 "../src/taquin-game.vala"
						_tmp14_ = self->priv->tiles;
#line 253 "../src/taquin-game.vala"
						_tmp14__length1 = self->priv->tiles_length1;
#line 253 "../src/taquin-game.vala"
						_tmp14__length2 = self->priv->tiles_length2;
#line 253 "../src/taquin-game.vala"
						_tmp15_ = self->priv->tiles;
#line 253 "../src/taquin-game.vala"
						_tmp15__length1 = self->priv->tiles_length1;
#line 253 "../src/taquin-game.vala"
						_tmp15__length2 = self->priv->tiles_length2;
#line 253 "../src/taquin-game.vala"
						_tmp16_ = _tmp15_[((i + 1) * _tmp15__length2) + y];
#line 253 "../src/taquin-game.vala"
						_tmp14_[(i * _tmp14__length2) + y] = _tmp16_;
#line 1606 "taquin-game.c"
					}
				}
			}
#line 254 "../src/taquin-game.vala"
			_tmp17_ = self->priv->tiles;
#line 254 "../src/taquin-game.vala"
			_tmp17__length1 = self->priv->tiles_length1;
#line 254 "../src/taquin-game.vala"
			_tmp17__length2 = self->priv->tiles_length2;
#line 254 "../src/taquin-game.vala"
			_tmp18_ = self->priv->_size;
#line 254 "../src/taquin-game.vala"
			_tmp17_[((_tmp18_ - 1) * _tmp17__length2) + y] = tmp;
#line 255 "../src/taquin-game.vala"
			_tmp19_ = self->priv->_size;
#line 255 "../src/taquin-game.vala"
			new_coord = (gint8) (_tmp19_ - 1);
#line 1624 "taquin-game.c"
		} else {
			gint8 tmp = 0;
			gint8* _tmp20_;
			gint _tmp20__length1;
			gint _tmp20__length2;
			gint8 _tmp21_;
			gint8 _tmp22_;
			gint8* _tmp29_;
			gint _tmp29__length1;
			gint _tmp29__length2;
#line 259 "../src/taquin-game.vala"
			_tmp20_ = self->priv->tiles;
#line 259 "../src/taquin-game.vala"
			_tmp20__length1 = self->priv->tiles_length1;
#line 259 "../src/taquin-game.vala"
			_tmp20__length2 = self->priv->tiles_length2;
#line 259 "../src/taquin-game.vala"
			_tmp21_ = self->priv->_size;
#line 259 "../src/taquin-game.vala"
			_tmp22_ = _tmp20_[((_tmp21_ - 1) * _tmp20__length2) + y];
#line 259 "../src/taquin-game.vala"
			tmp = _tmp22_;
#line 1647 "taquin-game.c"
			{
				guint8 i = 0U;
				gint8 _tmp23_;
#line 260 "../src/taquin-game.vala"
				_tmp23_ = self->priv->_size;
#line 260 "../src/taquin-game.vala"
				i = (guint8) (_tmp23_ - 1);
#line 1655 "taquin-game.c"
				{
					gboolean _tmp24_ = FALSE;
#line 260 "../src/taquin-game.vala"
					_tmp24_ = TRUE;
#line 260 "../src/taquin-game.vala"
					while (TRUE) {
#line 1662 "taquin-game.c"
						gint8* _tmp26_;
						gint _tmp26__length1;
						gint _tmp26__length2;
						gint8* _tmp27_;
						gint _tmp27__length1;
						gint _tmp27__length2;
						gint8 _tmp28_;
#line 260 "../src/taquin-game.vala"
						if (!_tmp24_) {
#line 1672 "taquin-game.c"
							guint8 _tmp25_;
#line 260 "../src/taquin-game.vala"
							_tmp25_ = i;
#line 260 "../src/taquin-game.vala"
							i = _tmp25_ - 1;
#line 1678 "taquin-game.c"
						}
#line 260 "../src/taquin-game.vala"
						_tmp24_ = FALSE;
#line 260 "../src/taquin-game.vala"
						if (!(((gint) i) > 0)) {
#line 260 "../src/taquin-game.vala"
							break;
#line 1686 "taquin-game.c"
						}
#line 261 "../src/taquin-game.vala"
						_tmp26_ = self->priv->tiles;
#line 261 "../src/taquin-game.vala"
						_tmp26__length1 = self->priv->tiles_length1;
#line 261 "../src/taquin-game.vala"
						_tmp26__length2 = self->priv->tiles_length2;
#line 261 "../src/taquin-game.vala"
						_tmp27_ = self->priv->tiles;
#line 261 "../src/taquin-game.vala"
						_tmp27__length1 = self->priv->tiles_length1;
#line 261 "../src/taquin-game.vala"
						_tmp27__length2 = self->priv->tiles_length2;
#line 261 "../src/taquin-game.vala"
						_tmp28_ = _tmp27_[((i - 1) * _tmp27__length2) + y];
#line 261 "../src/taquin-game.vala"
						_tmp26_[(i * _tmp26__length2) + y] = _tmp28_;
#line 1704 "taquin-game.c"
					}
				}
			}
#line 262 "../src/taquin-game.vala"
			_tmp29_ = self->priv->tiles;
#line 262 "../src/taquin-game.vala"
			_tmp29__length1 = self->priv->tiles_length1;
#line 262 "../src/taquin-game.vala"
			_tmp29__length2 = self->priv->tiles_length2;
#line 262 "../src/taquin-game.vala"
			_tmp29_[(0 * _tmp29__length2) + y] = tmp;
#line 263 "../src/taquin-game.vala"
			new_coord = (gint8) 0;
#line 1718 "taquin-game.c"
		}
	} else {
#line 268 "../src/taquin-game.vala"
		if (((gint) y) < 0) {
#line 1723 "taquin-game.c"
			gint8 tmp = 0;
			gint8* _tmp30_;
			gint _tmp30__length1;
			gint _tmp30__length2;
			gint8 _tmp31_;
			gint8* _tmp38_;
			gint _tmp38__length1;
			gint _tmp38__length2;
			gint8 _tmp39_;
			gint8 _tmp40_;
#line 270 "../src/taquin-game.vala"
			_tmp30_ = self->priv->tiles;
#line 270 "../src/taquin-game.vala"
			_tmp30__length1 = self->priv->tiles_length1;
#line 270 "../src/taquin-game.vala"
			_tmp30__length2 = self->priv->tiles_length2;
#line 270 "../src/taquin-game.vala"
			_tmp31_ = _tmp30_[(x * _tmp30__length2) + 0];
#line 270 "../src/taquin-game.vala"
			tmp = _tmp31_;
#line 1744 "taquin-game.c"
			{
				guint8 i = 0U;
#line 271 "../src/taquin-game.vala"
				i = (guint8) 0;
#line 1749 "taquin-game.c"
				{
					gboolean _tmp32_ = FALSE;
#line 271 "../src/taquin-game.vala"
					_tmp32_ = TRUE;
#line 271 "../src/taquin-game.vala"
					while (TRUE) {
#line 1756 "taquin-game.c"
						gint8 _tmp34_;
						gint8* _tmp35_;
						gint _tmp35__length1;
						gint _tmp35__length2;
						gint8* _tmp36_;
						gint _tmp36__length1;
						gint _tmp36__length2;
						gint8 _tmp37_;
#line 271 "../src/taquin-game.vala"
						if (!_tmp32_) {
#line 1767 "taquin-game.c"
							guint8 _tmp33_;
#line 271 "../src/taquin-game.vala"
							_tmp33_ = i;
#line 271 "../src/taquin-game.vala"
							i = _tmp33_ + 1;
#line 1773 "taquin-game.c"
						}
#line 271 "../src/taquin-game.vala"
						_tmp32_ = FALSE;
#line 271 "../src/taquin-game.vala"
						_tmp34_ = self->priv->_size;
#line 271 "../src/taquin-game.vala"
						if (!(((gint) i) < (_tmp34_ - 1))) {
#line 271 "../src/taquin-game.vala"
							break;
#line 1783 "taquin-game.c"
						}
#line 272 "../src/taquin-game.vala"
						_tmp35_ = self->priv->tiles;
#line 272 "../src/taquin-game.vala"
						_tmp35__length1 = self->priv->tiles_length1;
#line 272 "../src/taquin-game.vala"
						_tmp35__length2 = self->priv->tiles_length2;
#line 272 "../src/taquin-game.vala"
						_tmp36_ = self->priv->tiles;
#line 272 "../src/taquin-game.vala"
						_tmp36__length1 = self->priv->tiles_length1;
#line 272 "../src/taquin-game.vala"
						_tmp36__length2 = self->priv->tiles_length2;
#line 272 "../src/taquin-game.vala"
						_tmp37_ = _tmp36_[(x * _tmp36__length2) + (i + 1)];
#line 272 "../src/taquin-game.vala"
						_tmp35_[(x * _tmp35__length2) + i] = _tmp37_;
#line 1801 "taquin-game.c"
					}
				}
			}
#line 273 "../src/taquin-game.vala"
			_tmp38_ = self->priv->tiles;
#line 273 "../src/taquin-game.vala"
			_tmp38__length1 = self->priv->tiles_length1;
#line 273 "../src/taquin-game.vala"
			_tmp38__length2 = self->priv->tiles_length2;
#line 273 "../src/taquin-game.vala"
			_tmp39_ = self->priv->_size;
#line 273 "../src/taquin-game.vala"
			_tmp38_[(x * _tmp38__length2) + (_tmp39_ - 1)] = tmp;
#line 274 "../src/taquin-game.vala"
			_tmp40_ = self->priv->_size;
#line 274 "../src/taquin-game.vala"
			new_coord = (gint8) (_tmp40_ - 1);
#line 1819 "taquin-game.c"
		} else {
			gint8 tmp = 0;
			gint8* _tmp41_;
			gint _tmp41__length1;
			gint _tmp41__length2;
			gint8 _tmp42_;
			gint8 _tmp43_;
			gint8* _tmp50_;
			gint _tmp50__length1;
			gint _tmp50__length2;
#line 278 "../src/taquin-game.vala"
			_tmp41_ = self->priv->tiles;
#line 278 "../src/taquin-game.vala"
			_tmp41__length1 = self->priv->tiles_length1;
#line 278 "../src/taquin-game.vala"
			_tmp41__length2 = self->priv->tiles_length2;
#line 278 "../src/taquin-game.vala"
			_tmp42_ = self->priv->_size;
#line 278 "../src/taquin-game.vala"
			_tmp43_ = _tmp41_[(x * _tmp41__length2) + (_tmp42_ - 1)];
#line 278 "../src/taquin-game.vala"
			tmp = _tmp43_;
#line 1842 "taquin-game.c"
			{
				guint8 i = 0U;
				gint8 _tmp44_;
#line 279 "../src/taquin-game.vala"
				_tmp44_ = self->priv->_size;
#line 279 "../src/taquin-game.vala"
				i = (guint8) (_tmp44_ - 1);
#line 1850 "taquin-game.c"
				{
					gboolean _tmp45_ = FALSE;
#line 279 "../src/taquin-game.vala"
					_tmp45_ = TRUE;
#line 279 "../src/taquin-game.vala"
					while (TRUE) {
#line 1857 "taquin-game.c"
						gint8* _tmp47_;
						gint _tmp47__length1;
						gint _tmp47__length2;
						gint8* _tmp48_;
						gint _tmp48__length1;
						gint _tmp48__length2;
						gint8 _tmp49_;
#line 279 "../src/taquin-game.vala"
						if (!_tmp45_) {
#line 1867 "taquin-game.c"
							guint8 _tmp46_;
#line 279 "../src/taquin-game.vala"
							_tmp46_ = i;
#line 279 "../src/taquin-game.vala"
							i = _tmp46_ - 1;
#line 1873 "taquin-game.c"
						}
#line 279 "../src/taquin-game.vala"
						_tmp45_ = FALSE;
#line 279 "../src/taquin-game.vala"
						if (!(((gint) i) > 0)) {
#line 279 "../src/taquin-game.vala"
							break;
#line 1881 "taquin-game.c"
						}
#line 280 "../src/taquin-game.vala"
						_tmp47_ = self->priv->tiles;
#line 280 "../src/taquin-game.vala"
						_tmp47__length1 = self->priv->tiles_length1;
#line 280 "../src/taquin-game.vala"
						_tmp47__length2 = self->priv->tiles_length2;
#line 280 "../src/taquin-game.vala"
						_tmp48_ = self->priv->tiles;
#line 280 "../src/taquin-game.vala"
						_tmp48__length1 = self->priv->tiles_length1;
#line 280 "../src/taquin-game.vala"
						_tmp48__length2 = self->priv->tiles_length2;
#line 280 "../src/taquin-game.vala"
						_tmp49_ = _tmp48_[(x * _tmp48__length2) + (i - 1)];
#line 280 "../src/taquin-game.vala"
						_tmp47_[(x * _tmp47__length2) + i] = _tmp49_;
#line 1899 "taquin-game.c"
					}
				}
			}
#line 281 "../src/taquin-game.vala"
			_tmp50_ = self->priv->tiles;
#line 281 "../src/taquin-game.vala"
			_tmp50__length1 = self->priv->tiles_length1;
#line 281 "../src/taquin-game.vala"
			_tmp50__length2 = self->priv->tiles_length2;
#line 281 "../src/taquin-game.vala"
			_tmp50_[(x * _tmp50__length2) + 0] = tmp;
#line 282 "../src/taquin-game.vala"
			new_coord = (gint8) 0;
#line 1913 "taquin-game.c"
		}
	}
#line 286 "../src/taquin-game.vala"
	if (undoing) {
#line 288 "../src/taquin-game.vala"
		if (self->priv->moves_count == ((guint) 0)) {
#line 289 "../src/taquin-game.vala"
			g_assert_not_reached ();
#line 1922 "taquin-game.c"
		}
#line 290 "../src/taquin-game.vala"
		if (self->priv->moves_count != G_MAXUINT) {
#line 1926 "taquin-game.c"
			guint _tmp51_;
#line 291 "../src/taquin-game.vala"
			_tmp51_ = self->priv->moves_count;
#line 291 "../src/taquin-game.vala"
			self->priv->moves_count = _tmp51_ - 1;
#line 1932 "taquin-game.c"
		}
	} else {
		gint _tmp52_ = 0;
		gint8 _tmp55_ = 0;
#line 295 "../src/taquin-game.vala"
		if (move_x_axis) {
#line 1939 "taquin-game.c"
			gint _tmp53_ = 0;
#line 295 "../src/taquin-game.vala"
			if (((gint) new_coord) == 0) {
#line 295 "../src/taquin-game.vala"
				_tmp53_ = -1;
#line 1945 "taquin-game.c"
			} else {
				gint8 _tmp54_;
#line 295 "../src/taquin-game.vala"
				_tmp54_ = self->priv->_size;
#line 295 "../src/taquin-game.vala"
				_tmp53_ = (gint) _tmp54_;
#line 1952 "taquin-game.c"
			}
#line 295 "../src/taquin-game.vala"
			_tmp52_ = _tmp53_;
#line 1956 "taquin-game.c"
		} else {
#line 295 "../src/taquin-game.vala"
			_tmp52_ = (gint) x;
#line 1960 "taquin-game.c"
		}
#line 295 "../src/taquin-game.vala"
		if (move_x_axis) {
#line 295 "../src/taquin-game.vala"
			_tmp55_ = y;
#line 1966 "taquin-game.c"
		} else {
			gint _tmp56_ = 0;
#line 295 "../src/taquin-game.vala"
			if (((gint) new_coord) == 0) {
#line 295 "../src/taquin-game.vala"
				_tmp56_ = -1;
#line 1973 "taquin-game.c"
			} else {
				gint8 _tmp57_;
#line 295 "../src/taquin-game.vala"
				_tmp57_ = self->priv->_size;
#line 295 "../src/taquin-game.vala"
				_tmp56_ = (gint) _tmp57_;
#line 1980 "taquin-game.c"
			}
#line 295 "../src/taquin-game.vala"
			_tmp55_ = (gint8) _tmp56_;
#line 1984 "taquin-game.c"
		}
#line 295 "../src/taquin-game.vala"
		game_add_move (self, (gint8) _tmp52_, _tmp55_);
#line 296 "../src/taquin-game.vala"
		if (self->priv->moves_count != G_MAXUINT) {
#line 1990 "taquin-game.c"
			guint _tmp58_;
#line 297 "../src/taquin-game.vala"
			_tmp58_ = self->priv->moves_count;
#line 297 "../src/taquin-game.vala"
			self->priv->moves_count = _tmp58_ + 1;
#line 1996 "taquin-game.c"
		}
	}
#line 301 "../src/taquin-game.vala"
	if (((gint) new_coord) == 0) {
#line 2001 "taquin-game.c"
		gint8 _tmp60_;
#line 301 "../src/taquin-game.vala"
		_tmp60_ = self->priv->_size;
#line 301 "../src/taquin-game.vala"
		_tmp59_ = _tmp60_ - 1;
#line 2007 "taquin-game.c"
	} else {
		gint8 _tmp61_;
#line 301 "../src/taquin-game.vala"
		_tmp61_ = self->priv->_size;
#line 301 "../src/taquin-game.vala"
		_tmp59_ = 1 - _tmp61_;
#line 2014 "taquin-game.c"
	}
#line 302 "../src/taquin-game.vala"
	if (move_x_axis) {
#line 302 "../src/taquin-game.vala"
		_tmp62_ = new_coord;
#line 2020 "taquin-game.c"
	} else {
#line 302 "../src/taquin-game.vala"
		_tmp62_ = x;
#line 2024 "taquin-game.c"
	}
#line 303 "../src/taquin-game.vala"
	if (move_x_axis) {
#line 303 "../src/taquin-game.vala"
		_tmp63_ = y;
#line 2030 "taquin-game.c"
	} else {
#line 303 "../src/taquin-game.vala"
		_tmp63_ = new_coord;
#line 2034 "taquin-game.c"
	}
#line 305 "../src/taquin-game.vala"
	if (restarting) {
#line 305 "../src/taquin-game.vala"
		_tmp64_ = TRUE;
#line 2040 "taquin-game.c"
	} else {
		gboolean _tmp65_ = FALSE;
#line 305 "../src/taquin-game.vala"
		if (was_complete) {
#line 305 "../src/taquin-game.vala"
			_tmp65_ = undoing;
#line 2047 "taquin-game.c"
		} else {
#line 305 "../src/taquin-game.vala"
			_tmp65_ = FALSE;
#line 2051 "taquin-game.c"
		}
#line 305 "../src/taquin-game.vala"
		_tmp64_ = _tmp65_;
#line 2055 "taquin-game.c"
	}
#line 300 "../src/taquin-game.vala"
	g_signal_emit (self, game_signals[GAME_MOVE_SIGNAL], 0, move_x_axis, (gint8) _tmp59_, _tmp62_, _tmp63_, self->priv->moves_count, _tmp64_);
#line 306 "../src/taquin-game.vala"
	_tmp66_ = game_check_complete (&self->priv->tiles, (gint*) (&self->priv->tiles_length1), (gint*) (&self->priv->tiles_length2));
#line 306 "../src/taquin-game.vala"
	if (_tmp66_) {
#line 307 "../src/taquin-game.vala"
		g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
#line 2065 "taquin-game.c"
	}
}

static gboolean
game_check_complete (gint8** tiles,
                     gint* tiles_length1,
                     gint* tiles_length2)
{
	guint8 size = 0U;
	gint _tmp0_;
	gboolean result;
#line 312 "../src/taquin-game.vala"
	_tmp0_ = *tiles_length1;
#line 312 "../src/taquin-game.vala"
	size = (guint8) _tmp0_;
#line 2081 "taquin-game.c"
	{
		guint8 i = 0U;
#line 313 "../src/taquin-game.vala"
		i = (guint8) 1;
#line 2086 "taquin-game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 313 "../src/taquin-game.vala"
			_tmp1_ = TRUE;
#line 313 "../src/taquin-game.vala"
			while (TRUE) {
#line 2093 "taquin-game.c"
				gint8 _tmp3_;
#line 313 "../src/taquin-game.vala"
				if (!_tmp1_) {
#line 2097 "taquin-game.c"
					guint8 _tmp2_;
#line 313 "../src/taquin-game.vala"
					_tmp2_ = i;
#line 313 "../src/taquin-game.vala"
					i = _tmp2_ + 1;
#line 2103 "taquin-game.c"
				}
#line 313 "../src/taquin-game.vala"
				_tmp1_ = FALSE;
#line 313 "../src/taquin-game.vala"
				if (!(i < (size * size))) {
#line 313 "../src/taquin-game.vala"
					break;
#line 2111 "taquin-game.c"
				}
#line 314 "../src/taquin-game.vala"
				_tmp3_ = (*tiles)[((i % size) * (*tiles_length2)) + (i / size)];
#line 314 "../src/taquin-game.vala"
				if (i != ((guint8) _tmp3_)) {
#line 315 "../src/taquin-game.vala"
					result = FALSE;
#line 315 "../src/taquin-game.vala"
					return result;
#line 2121 "taquin-game.c"
				}
			}
		}
	}
#line 316 "../src/taquin-game.vala"
	result = TRUE;
#line 316 "../src/taquin-game.vala"
	return result;
#line 2130 "taquin-game.c"
}

static gpointer
_game_undo_item_dup0 (gpointer self)
{
#line 341 "../src/taquin-game.vala"
	return self ? game_undo_item_dup (self) : NULL;
#line 2138 "taquin-game.c"
}

void
game_undo (Game* self)
{
	GameUndoItem* _tmp0_;
	GameType _tmp1_;
	GameUndoItem* _tmp6_;
	GameUndoItem* _tmp7_;
	GameUndoItem* _tmp8_ = NULL;
	GameUndoItem* _tmp9_;
	GameUndoItem* _tmp12_;
#line 331 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/taquin-game.vala"
	_tmp0_ = self->priv->state;
#line 333 "../src/taquin-game.vala"
	if (_tmp0_ == NULL) {
#line 334 "../src/taquin-game.vala"
		return;
#line 2159 "taquin-game.c"
	}
#line 336 "../src/taquin-game.vala"
	_tmp1_ = self->priv->_game_type;
#line 336 "../src/taquin-game.vala"
	if (_tmp1_ == GAME_TYPE_FIFTEEN) {
#line 2165 "taquin-game.c"
		GameUndoItem* _tmp2_;
		GameUndoItem* _tmp3_;
#line 337 "../src/taquin-game.vala"
		_tmp2_ = self->priv->state;
#line 337 "../src/taquin-game.vala"
		_tmp3_ = self->priv->state;
#line 337 "../src/taquin-game.vala"
		game_fifteen_move (self, ((GameUndoItem) (*_tmp2_)).x, ((GameUndoItem) (*_tmp3_)).y, TRUE, FALSE);
#line 2174 "taquin-game.c"
	} else {
		GameUndoItem* _tmp4_;
		GameUndoItem* _tmp5_;
#line 339 "../src/taquin-game.vala"
		_tmp4_ = self->priv->state;
#line 339 "../src/taquin-game.vala"
		_tmp5_ = self->priv->state;
#line 339 "../src/taquin-game.vala"
		game_sixteen_move (self, ((GameUndoItem) (*_tmp4_)).x, ((GameUndoItem) (*_tmp5_)).y, TRUE, FALSE);
#line 2184 "taquin-game.c"
	}
#line 341 "../src/taquin-game.vala"
	_tmp6_ = self->priv->previous_state;
#line 341 "../src/taquin-game.vala"
	_tmp7_ = _game_undo_item_dup0 (_tmp6_);
#line 341 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->state);
#line 341 "../src/taquin-game.vala"
	self->priv->state = _tmp7_;
#line 342 "../src/taquin-game.vala"
	_tmp9_ = self->priv->state;
#line 342 "../src/taquin-game.vala"
	if (_tmp9_ == NULL) {
#line 342 "../src/taquin-game.vala"
		_tmp8_ = NULL;
#line 2200 "taquin-game.c"
	} else {
		GameUndoItem* _tmp10_;
		GameUndoItem* _tmp11_;
#line 342 "../src/taquin-game.vala"
		_tmp10_ = self->priv->state;
#line 342 "../src/taquin-game.vala"
		_tmp11_ = ((GameUndoItem) (*_tmp10_)).previous;
#line 342 "../src/taquin-game.vala"
		_tmp8_ = _tmp11_;
#line 2210 "taquin-game.c"
	}
#line 342 "../src/taquin-game.vala"
	_tmp12_ = _game_undo_item_dup0 (_tmp8_);
#line 342 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->previous_state);
#line 342 "../src/taquin-game.vala"
	self->priv->previous_state = _tmp12_;
#line 2218 "taquin-game.c"
}

void
game_restart (Game* self)
{
#line 345 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/taquin-game.vala"
	while (TRUE) {
#line 2228 "taquin-game.c"
		GameUndoItem* _tmp0_;
		GameType _tmp1_;
		GameUndoItem* _tmp6_;
		GameUndoItem* _tmp7_;
		GameUndoItem* _tmp8_ = NULL;
		GameUndoItem* _tmp9_;
		GameUndoItem* _tmp12_;
#line 347 "../src/taquin-game.vala"
		_tmp0_ = self->priv->state;
#line 347 "../src/taquin-game.vala"
		if (!(_tmp0_ != NULL)) {
#line 347 "../src/taquin-game.vala"
			break;
#line 2242 "taquin-game.c"
		}
#line 349 "../src/taquin-game.vala"
		_tmp1_ = self->priv->_game_type;
#line 349 "../src/taquin-game.vala"
		if (_tmp1_ == GAME_TYPE_FIFTEEN) {
#line 2248 "taquin-game.c"
			GameUndoItem* _tmp2_;
			GameUndoItem* _tmp3_;
#line 350 "../src/taquin-game.vala"
			_tmp2_ = self->priv->state;
#line 350 "../src/taquin-game.vala"
			_tmp3_ = self->priv->state;
#line 350 "../src/taquin-game.vala"
			game_fifteen_move (self, ((GameUndoItem) (*_tmp2_)).x, ((GameUndoItem) (*_tmp3_)).y, TRUE, TRUE);
#line 2257 "taquin-game.c"
		} else {
			GameUndoItem* _tmp4_;
			GameUndoItem* _tmp5_;
#line 352 "../src/taquin-game.vala"
			_tmp4_ = self->priv->state;
#line 352 "../src/taquin-game.vala"
			_tmp5_ = self->priv->state;
#line 352 "../src/taquin-game.vala"
			game_sixteen_move (self, ((GameUndoItem) (*_tmp4_)).x, ((GameUndoItem) (*_tmp5_)).y, TRUE, TRUE);
#line 2267 "taquin-game.c"
		}
#line 354 "../src/taquin-game.vala"
		_tmp6_ = self->priv->previous_state;
#line 354 "../src/taquin-game.vala"
		_tmp7_ = _game_undo_item_dup0 (_tmp6_);
#line 354 "../src/taquin-game.vala"
		_game_undo_item_free0 (self->priv->state);
#line 354 "../src/taquin-game.vala"
		self->priv->state = _tmp7_;
#line 355 "../src/taquin-game.vala"
		_tmp9_ = self->priv->state;
#line 355 "../src/taquin-game.vala"
		if (_tmp9_ == NULL) {
#line 355 "../src/taquin-game.vala"
			_tmp8_ = NULL;
#line 2283 "taquin-game.c"
		} else {
			GameUndoItem* _tmp10_;
			GameUndoItem* _tmp11_;
#line 355 "../src/taquin-game.vala"
			_tmp10_ = self->priv->state;
#line 355 "../src/taquin-game.vala"
			_tmp11_ = ((GameUndoItem) (*_tmp10_)).previous;
#line 355 "../src/taquin-game.vala"
			_tmp8_ = _tmp11_;
#line 2293 "taquin-game.c"
		}
#line 355 "../src/taquin-game.vala"
		_tmp12_ = _game_undo_item_dup0 (_tmp8_);
#line 355 "../src/taquin-game.vala"
		_game_undo_item_free0 (self->priv->previous_state);
#line 355 "../src/taquin-game.vala"
		self->priv->previous_state = _tmp12_;
#line 2301 "taquin-game.c"
	}
}

static void
game_add_move (Game* self,
               gint8 x_gap,
               gint8 y_gap)
{
	GameUndoItem* _tmp0_ = NULL;
	GameUndoItem* _tmp1_;
	GameUndoItem* _tmp3_;
	GameUndoItem* _tmp4_;
	GameUndoItem* _tmp5_;
	GameUndoItem _tmp6_ = {0};
	GameUndoItem _tmp7_;
	GameUndoItem* _tmp8_;
	GameUndoItem* _tmp9_;
	GameUndoItem* _tmp10_;
	GameUndoItem* _tmp11_;
	GameUndoItem* _tmp12_;
	GameUndoItem* _tmp13_;
	GameUndoItem* _tmp14_;
	GameUndoItem* _tmp15_;
	GameUndoItem* _tmp16_;
	GameUndoItem _tmp17_ = {0};
	GameUndoItem _tmp18_;
	GameUndoItem* _tmp19_;
#line 359 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/taquin-game.vala"
	_tmp1_ = self->priv->state;
#line 361 "../src/taquin-game.vala"
	if (_tmp1_ == NULL) {
#line 361 "../src/taquin-game.vala"
		_tmp0_ = NULL;
#line 2337 "taquin-game.c"
	} else {
		GameUndoItem* _tmp2_;
#line 361 "../src/taquin-game.vala"
		_tmp2_ = self->priv->state;
#line 361 "../src/taquin-game.vala"
		_tmp0_ = _tmp2_;
#line 2344 "taquin-game.c"
	}
#line 361 "../src/taquin-game.vala"
	_tmp3_ = _game_undo_item_dup0 (_tmp0_);
#line 361 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->previous_state);
#line 361 "../src/taquin-game.vala"
	self->priv->previous_state = _tmp3_;
#line 362 "../src/taquin-game.vala"
	_tmp4_ = self->priv->previous_state;
#line 362 "../src/taquin-game.vala"
	_tmp5_ = _game_undo_item_dup0 (_tmp4_);
#line 362 "../src/taquin-game.vala"
	memset (&_tmp6_, 0, sizeof (GameUndoItem));
#line 362 "../src/taquin-game.vala"
	_tmp6_.x = x_gap;
#line 362 "../src/taquin-game.vala"
	_tmp6_.y = y_gap;
#line 362 "../src/taquin-game.vala"
	_game_undo_item_free0 (_tmp6_.next);
#line 362 "../src/taquin-game.vala"
	_tmp6_.next = NULL;
#line 362 "../src/taquin-game.vala"
	_game_undo_item_free0 (_tmp6_.previous);
#line 362 "../src/taquin-game.vala"
	_tmp6_.previous = _tmp5_;
#line 362 "../src/taquin-game.vala"
	_tmp7_ = _tmp6_;
#line 362 "../src/taquin-game.vala"
	_tmp8_ = _game_undo_item_dup0 (&_tmp7_);
#line 362 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->state);
#line 362 "../src/taquin-game.vala"
	self->priv->state = _tmp8_;
#line 362 "../src/taquin-game.vala"
	game_undo_item_destroy (&_tmp7_);
#line 363 "../src/taquin-game.vala"
	_tmp9_ = self->priv->previous_state;
#line 363 "../src/taquin-game.vala"
	if (_tmp9_ == NULL) {
#line 364 "../src/taquin-game.vala"
		return;
#line 2386 "taquin-game.c"
	}
#line 365 "../src/taquin-game.vala"
	_tmp10_ = self->priv->previous_state;
#line 365 "../src/taquin-game.vala"
	_tmp11_ = self->priv->previous_state;
#line 365 "../src/taquin-game.vala"
	_tmp12_ = self->priv->state;
#line 365 "../src/taquin-game.vala"
	_tmp13_ = _game_undo_item_dup0 (_tmp12_);
#line 365 "../src/taquin-game.vala"
	_tmp14_ = self->priv->previous_state;
#line 365 "../src/taquin-game.vala"
	_tmp15_ = ((GameUndoItem) (*_tmp14_)).previous;
#line 365 "../src/taquin-game.vala"
	_tmp16_ = _game_undo_item_dup0 (_tmp15_);
#line 365 "../src/taquin-game.vala"
	memset (&_tmp17_, 0, sizeof (GameUndoItem));
#line 365 "../src/taquin-game.vala"
	_tmp17_.x = ((GameUndoItem) (*_tmp10_)).x;
#line 365 "../src/taquin-game.vala"
	_tmp17_.y = ((GameUndoItem) (*_tmp11_)).y;
#line 365 "../src/taquin-game.vala"
	_game_undo_item_free0 (_tmp17_.next);
#line 365 "../src/taquin-game.vala"
	_tmp17_.next = _tmp13_;
#line 365 "../src/taquin-game.vala"
	_game_undo_item_free0 (_tmp17_.previous);
#line 365 "../src/taquin-game.vala"
	_tmp17_.previous = _tmp16_;
#line 365 "../src/taquin-game.vala"
	_tmp18_ = _tmp17_;
#line 365 "../src/taquin-game.vala"
	_tmp19_ = _game_undo_item_dup0 (&_tmp18_);
#line 365 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->previous_state);
#line 365 "../src/taquin-game.vala"
	self->priv->previous_state = _tmp19_;
#line 365 "../src/taquin-game.vala"
	game_undo_item_destroy (&_tmp18_);
#line 2426 "taquin-game.c"
}

gint8
game_get_size (Game* self)
{
	gint8 result;
#line 39 "../src/taquin-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/taquin-game.vala"
	result = self->priv->_size;
#line 39 "../src/taquin-game.vala"
	return result;
#line 2439 "taquin-game.c"
}

static void
game_set_size (Game* self,
               gint8 value)
{
#line 39 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/taquin-game.vala"
	self->priv->_size = value;
#line 2450 "taquin-game.c"
}

GameType
game_get_game_type (Game* self)
{
	GameType result;
#line 40 "../src/taquin-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../src/taquin-game.vala"
	result = self->priv->_game_type;
#line 40 "../src/taquin-game.vala"
	return result;
#line 2463 "taquin-game.c"
}

static void
game_set_game_type (Game* self,
                    GameType value)
{
#line 40 "../src/taquin-game.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/taquin-game.vala"
	self->priv->_game_type = value;
#line 2474 "taquin-game.c"
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_CHAR_CHAR_CHAR_UINT_BOOLEAN (GClosure * closure,
                                                                   GValue * return_value,
                                                                   guint n_param_values,
                                                                   const GValue * param_values,
                                                                   gpointer invocation_hint,
                                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_CHAR_CHAR_CHAR_UINT_BOOLEAN) (gpointer data1, gboolean arg_1, gint8 arg_2, gint8 arg_3, gint8 arg_4, guint arg_5, gboolean arg_6, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_CHAR_CHAR_CHAR_UINT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "../src/taquin-game.vala"
	g_return_if_fail (n_param_values == 7);
#line 37 "../src/taquin-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "../src/taquin-game.vala"
		data1 = closure->data;
#line 37 "../src/taquin-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 2499 "taquin-game.c"
	} else {
#line 37 "../src/taquin-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "../src/taquin-game.vala"
		data2 = closure->data;
#line 2505 "taquin-game.c"
	}
#line 37 "../src/taquin-game.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_CHAR_CHAR_CHAR_UINT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 37 "../src/taquin-game.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_char (param_values + 2), g_value_get_char (param_values + 3), g_value_get_char (param_values + 4), g_value_get_uint (param_values + 5), g_value_get_boolean (param_values + 6), data2);
#line 2511 "taquin-game.c"
}

static void
g_cclosure_user_marshal_VOID__ENUM_BOOLEAN (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "../src/taquin-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 37 "../src/taquin-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "../src/taquin-game.vala"
		data1 = closure->data;
#line 37 "../src/taquin-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 2536 "taquin-game.c"
	} else {
#line 37 "../src/taquin-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "../src/taquin-game.vala"
		data2 = closure->data;
#line 2542 "taquin-game.c"
	}
#line 37 "../src/taquin-game.vala"
	callback = (GMarshalFunc_VOID__ENUM_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 37 "../src/taquin-game.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 2548 "taquin-game.c"
}

static void
game_undo_item_copy (const GameUndoItem* self,
                     GameUndoItem* dest)
{
	GameUndoItem* _tmp0_;
	GameUndoItem* _tmp1_;
	GameUndoItem* _tmp2_;
	GameUndoItem* _tmp3_;
#line 323 "../src/taquin-game.vala"
	(*dest).x = (*self).x;
#line 323 "../src/taquin-game.vala"
	(*dest).y = (*self).y;
#line 323 "../src/taquin-game.vala"
	_tmp0_ = (*self).next;
#line 323 "../src/taquin-game.vala"
	_tmp1_ = _game_undo_item_dup0 (_tmp0_);
#line 323 "../src/taquin-game.vala"
	_game_undo_item_free0 ((*dest).next);
#line 323 "../src/taquin-game.vala"
	(*dest).next = _tmp1_;
#line 323 "../src/taquin-game.vala"
	_tmp2_ = (*self).previous;
#line 323 "../src/taquin-game.vala"
	_tmp3_ = _game_undo_item_dup0 (_tmp2_);
#line 323 "../src/taquin-game.vala"
	_game_undo_item_free0 ((*dest).previous);
#line 323 "../src/taquin-game.vala"
	(*dest).previous = _tmp3_;
#line 2579 "taquin-game.c"
}

static void
game_undo_item_destroy (GameUndoItem* self)
{
#line 327 "../src/taquin-game.vala"
	_game_undo_item_free0 ((*self).next);
#line 328 "../src/taquin-game.vala"
	_game_undo_item_free0 ((*self).previous);
#line 2589 "taquin-game.c"
}

static GameUndoItem*
game_undo_item_dup (const GameUndoItem* self)
{
	GameUndoItem* dup;
#line 323 "../src/taquin-game.vala"
	dup = g_new0 (GameUndoItem, 1);
#line 323 "../src/taquin-game.vala"
	game_undo_item_copy (self, dup);
#line 323 "../src/taquin-game.vala"
	return dup;
#line 2602 "taquin-game.c"
}

static void
game_undo_item_free (GameUndoItem* self)
{
#line 323 "../src/taquin-game.vala"
	game_undo_item_destroy (self);
#line 323 "../src/taquin-game.vala"
	g_free (self);
#line 2612 "taquin-game.c"
}

static GType
game_undo_item_get_type_once (void)
{
	GType game_undo_item_type_id;
	game_undo_item_type_id = g_boxed_type_register_static ("GameUndoItem", (GBoxedCopyFunc) game_undo_item_dup, (GBoxedFreeFunc) game_undo_item_free);
	return game_undo_item_type_id;
}

static GType
game_undo_item_get_type (void)
{
	static volatile gsize game_undo_item_type_id__once = 0;
	if (g_once_init_enter (&game_undo_item_type_id__once)) {
		GType game_undo_item_type_id;
		game_undo_item_type_id = game_undo_item_get_type_once ();
		g_once_init_leave (&game_undo_item_type_id__once, game_undo_item_type_id);
	}
	return game_undo_item_type_id__once;
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
#line 71 "../src/taquin-game.vala"
	parent_class = G_OBJECT_CLASS (game_parent_class);
#line 71 "../src/taquin-game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../src/taquin-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 2649 "taquin-game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 73 "../src/taquin-game.vala"
		_tmp0_ = TRUE;
#line 73 "../src/taquin-game.vala"
		while (TRUE) {
#line 2656 "taquin-game.c"
			GameType _tmp2_;
			gint8 _tmp3_;
			gint8* _tmp4_ = NULL;
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
#line 73 "../src/taquin-game.vala"
			if (!_tmp0_) {
#line 2664 "taquin-game.c"
				gboolean _tmp1_;
#line 73 "../src/taquin-game.vala"
				_tmp1_ = game_check_complete (&self->priv->tiles, (gint*) (&self->priv->tiles_length1), (gint*) (&self->priv->tiles_length2));
#line 73 "../src/taquin-game.vala"
				if (!_tmp1_) {
#line 73 "../src/taquin-game.vala"
					break;
#line 2672 "taquin-game.c"
				}
			}
#line 73 "../src/taquin-game.vala"
			_tmp0_ = FALSE;
#line 73 "../src/taquin-game.vala"
			_tmp2_ = self->priv->_game_type;
#line 73 "../src/taquin-game.vala"
			_tmp3_ = self->priv->_size;
#line 73 "../src/taquin-game.vala"
			game_generate_game (_tmp2_, _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 73 "../src/taquin-game.vala"
			self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 73 "../src/taquin-game.vala"
			self->priv->tiles = _tmp4_;
#line 73 "../src/taquin-game.vala"
			self->priv->tiles_length1 = _tmp5_;
#line 73 "../src/taquin-game.vala"
			self->priv->tiles_length2 = _tmp6_;
#line 2691 "taquin-game.c"
		}
	}
#line 71 "../src/taquin-game.vala"
	return obj;
#line 2696 "taquin-game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 37 "../src/taquin-game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/taquin-game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 37 "../src/taquin-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 37 "../src/taquin-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 37 "../src/taquin-game.vala"
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
#line 37 "../src/taquin-game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 37 "../src/taquin-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_char ("size", "size", "size", G_MININT8, G_MAXINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 37 "../src/taquin-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_GAME_TYPE_PROPERTY, game_properties[GAME_GAME_TYPE_PROPERTY] = g_param_spec_enum ("game-type", "game-type", "game-type", TYPE_GAME_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 37 "../src/taquin-game.vala"
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 37 "../src/taquin-game.vala"
	game_signals[GAME_MOVE_SIGNAL] = g_signal_new ("move", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_CHAR_CHAR_CHAR_UINT_BOOLEAN, G_TYPE_NONE, 6, G_TYPE_BOOLEAN, G_TYPE_CHAR, G_TYPE_CHAR, G_TYPE_CHAR, G_TYPE_UINT, G_TYPE_BOOLEAN);
#line 37 "../src/taquin-game.vala"
	game_signals[GAME_BAD_CLICK_SIGNAL] = g_signal_new ("bad-click", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_BOOLEAN, G_TYPE_NONE, 2, GAME_TYPE_BAD_CLICK, G_TYPE_BOOLEAN);
#line 2725 "taquin-game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
#line 37 "../src/taquin-game.vala"
	self->priv = game_get_instance_private (self);
#line 47 "../src/taquin-game.vala"
	self->priv->state = NULL;
#line 48 "../src/taquin-game.vala"
	self->priv->previous_state = NULL;
#line 49 "../src/taquin-game.vala"
	self->priv->moves_count = (guint) 0;
#line 52 "../src/taquin-game.vala"
	self->priv->x_gap = (gint8) 0;
#line 53 "../src/taquin-game.vala"
	self->priv->y_gap = (gint8) 0;
#line 2744 "taquin-game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 37 "../src/taquin-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 43 "../src/taquin-game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 47 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->state);
#line 48 "../src/taquin-game.vala"
	_game_undo_item_free0 (self->priv->previous_state);
#line 37 "../src/taquin-game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 2761 "taquin-game.c"
}

static GType
game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
	GType game_type_id;
	game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__once = 0;
	if (g_once_init_enter (&game_type_id__once)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__once, game_type_id);
	}
	return game_type_id__once;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 37 "../src/taquin-game.vala"
	switch (property_id) {
#line 37 "../src/taquin-game.vala"
		case GAME_SIZE_PROPERTY:
#line 37 "../src/taquin-game.vala"
		g_value_set_char (value, game_get_size (self));
#line 37 "../src/taquin-game.vala"
		break;
#line 37 "../src/taquin-game.vala"
		case GAME_GAME_TYPE_PROPERTY:
#line 37 "../src/taquin-game.vala"
		g_value_set_enum (value, game_get_game_type (self));
#line 37 "../src/taquin-game.vala"
		break;
#line 2808 "taquin-game.c"
		default:
#line 37 "../src/taquin-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/taquin-game.vala"
		break;
#line 2814 "taquin-game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 37 "../src/taquin-game.vala"
	switch (property_id) {
#line 37 "../src/taquin-game.vala"
		case GAME_SIZE_PROPERTY:
#line 37 "../src/taquin-game.vala"
		game_set_size (self, g_value_get_char (value));
#line 37 "../src/taquin-game.vala"
		break;
#line 37 "../src/taquin-game.vala"
		case GAME_GAME_TYPE_PROPERTY:
#line 37 "../src/taquin-game.vala"
		game_set_game_type (self, g_value_get_enum (value));
#line 37 "../src/taquin-game.vala"
		break;
#line 2840 "taquin-game.c"
		default:
#line 37 "../src/taquin-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/taquin-game.vala"
		break;
#line 2846 "taquin-game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

